GNU bug report logs - #57604
[ef]grep usage -> POSIXLY_CORRECT?

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: grep; Reported by: Karl Berry <karl@HIDDEN>; dated Mon, 5 Sep 2022 22:08:02 UTC; Maintainer for grep is bug-grep@HIDDEN.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 19 Sep 2022 20:43:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 19 16:43:39 2022
Received: from localhost ([127.0.0.1]:55431 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oaNc8-0006ii-9F
	for submit <at> debbugs.gnu.org; Mon, 19 Sep 2022 16:43:39 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:37242)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1oaNc3-0006iR-5f
 for 57604 <at> debbugs.gnu.org; Mon, 19 Sep 2022 16:43:35 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id E250C1600B8;
 Mon, 19 Sep 2022 13:43:24 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id bMFQXIz4YxHy; Mon, 19 Sep 2022 13:43:23 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 9F6741600BB;
 Mon, 19 Sep 2022 13:43:23 -0700 (PDT)
DKIM-Filter: OpenDKIM Filter v2.9.2 zimbra.cs.ucla.edu 9F6741600BB
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cs.ucla.edu;
 s=78364E5A-2AF3-11ED-87FA-8298ECA2D365; t=1663620203;
 bh=PzbbBkjZ4CwBHFFDHv4pMTZspbh6pYqPB/xcGQPcD7Q=;
 h=Message-ID:Date:MIME-Version:Subject:To:From:Content-Type:
 Content-Transfer-Encoding;
 b=EyzrRJxHkhRFn5tYyHggFj6Ii4/fEguWtcoZQCcOklka4Zx0+OYg9t0z/RuJ9FS3t
 PkLvVzeicYgC+d+MQoHScfpFmtbzfNAw1oLJ3rwKII9drIyFqnYKB8w/5muweDjaok
 RkSRdNEa4aIXMor/LG7nTsxYrcY3e6+wKFV+CIm8=
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id AylXqU964BNj; Mon, 19 Sep 2022 13:43:23 -0700 (PDT)
Received: from [192.168.1.163] (cpe-172-91-119-151.socal.res.rr.com
 [172.91.119.151])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 5EF951600BA;
 Mon, 19 Sep 2022 13:43:23 -0700 (PDT)
Message-ID: <b2d4fd7d-e66a-026d-d15c-2cad658b962e@HIDDEN>
Date: Mon, 19 Sep 2022 13:43:22 -0700
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
Subject: Re: bug#57604: Bug#1019724: warning: stray \ before - causes
 autopkgtest failure
Content-Language: en-US
To: =?UTF-8?Q?Santiago_Ruano_Rinc=c3=b3n?= <santiagorr@HIDDEN>
References: <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyGSlX7XPSXi366M@bartik>
 <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyHUIsQDNUYxtaYn@HIDDEN> <YyHzxEYSjWs/ZAEc@bartik>
 <a5e450e9-7212-812a-d882-773bc5cebde3@HIDDEN>
 <254eedc1-82a0-ea7f-d0c1-276bac3104ca@HIDDEN>
 <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyazTsyTAZnWB2c2@HIDDEN> <YyhhS86z7zBXPl53@bartik>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
In-Reply-To: <YyhhS86z7zBXPl53@bartik>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: 57604
Cc: Lucas Nussbaum <lucas@HIDDEN>, Jochen Sprickerhof <jspricke@HIDDEN>,
 57604 <at> debbugs.gnu.org, Paul Gevers <elbrus@HIDDEN>,
 1019724@HIDDEN, debian-release@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.1 (-----)

On 9/19/22 05:32, Santiago Ruano Rinc=C3=B3n wrote:

> as you can read below, there are 4235 packages including the
> warning in their build logs. Funnily, grep is also in the list :-)

Grep is on the list because Debian indirectly requires ucf to build=20
Grep, and ucf issues the warning about stray \ because ucf mistakenly=20
uses a Perlism in a grep regular expression=20
<https://bugs.debian.org/1019326>. This particular warning doesn't break=20
anything; it merely alerts installers of a screwup that happens to work=20
but relies on undefined results.

We're thinking about adding a configure-time option to Grep to disable=20
warnings about egrep/fgrep, to address the original Grep bug report=20
<https://bugs.gnu.org/57604>. I'm not so sure about disabling warnings=20
about bad escapes, as these warnings are so often a win and so rarely a=20
loss, as is the case with ucf. Of course there is a tradeoff here=20
between (a) having to wade through a bunch of annoying warnings, and (b)=20
fixing packages so that they don't rely on undefined results.

Since the main issue here seems to be libtool-related test failures, how=20
about patching libtool and letting the affected packages use the patched=20
libtool? You can find a patch here:

https://savannah.gnu.org/patch/index.php?10282
https://savannah.gnu.org/patch/download.php?file_id=3D53720

The libtool test failures are false alarms, so another option would be=20
to ignore the failures until libtool gets fixed.


For more on this thorny topic, please see:

https://www.gnu.org/software/grep/manual/html_node/Problematic-Expression=
s.html

The stray \ issue is the 19th bullet.




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 19 Sep 2022 12:32:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 19 08:32:22 2022
Received: from localhost ([127.0.0.1]:52632 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oaFwk-0004yp-8x
	for submit <at> debbugs.gnu.org; Mon, 19 Sep 2022 08:32:22 -0400
Received: from mx1.riseup.net ([198.252.153.129]:45046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <santiagorr@HIDDEN>) id 1oaFwi-0004yb-AR
 for 57604 <at> debbugs.gnu.org; Mon, 19 Sep 2022 08:32:21 -0400
Received: from fews2.riseup.net (fews2-pn.riseup.net [10.0.1.84])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx1.riseup.net (Postfix) with ESMTPS id 4MWPFV3KM0zDqZk;
 Mon, 19 Sep 2022 12:32:14 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1663590734; bh=ndznO2OFgc4sXoh4FTiEqiroAXLWZJnHHn4k7I13dIY=;
 h=Date:From:To:Cc:Subject:References:In-Reply-To:From;
 b=rMmrCZh+S/vdnkSQGHINtyE2gQp+AJy43FGWMpQXtYhJayk5oQsb/VwUwH+TKtrqc
 bkXiTneYnN5WdcPcS/Sk5PPDmv+rESjZkdI1EkBx081GLph9Qs12kFc/h63262QPKy
 rZWpn+B8VC7hVSVmGQt/KMxHw2hvG8C7xXk6/i3k=
X-Riseup-User-ID: 1507FA6F660C3EC8F961A384E8649F8A3A2A628F93D67A3454029700AE2BF1C6
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews2.riseup.net (Postfix) with ESMTPSA id 4MWPFT5R5Cz1y9N;
 Mon, 19 Sep 2022 12:32:13 +0000 (UTC)
Date: Mon, 19 Sep 2022 14:32:11 +0200
From: Santiago Ruano =?iso-8859-1?Q?Rinc=F3n?= <santiagorr@HIDDEN>
To: 1019724@HIDDEN, 57604 <at> debbugs.gnu.org
Subject: Re: Bug#1019724: warning: stray \ before - causes autopkgtest failure
Message-ID: <YyhhS86z7zBXPl53@bartik>
References: <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyGSlX7XPSXi366M@bartik>
 <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyHUIsQDNUYxtaYn@HIDDEN> <YyHzxEYSjWs/ZAEc@bartik>
 <a5e450e9-7212-812a-d882-773bc5cebde3@HIDDEN>
 <254eedc1-82a0-ea7f-d0c1-276bac3104ca@HIDDEN>
 <166313904465.1429097.13197112636531060530.reportbug@fenchel>
 <YyazTsyTAZnWB2c2@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature"; boundary="QjrpsK2OUUiVbJpn"
Content-Disposition: inline
In-Reply-To: <YyazTsyTAZnWB2c2@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57604
Cc: Lucas Nussbaum <lucas@HIDDEN>, Jochen Sprickerhof <jspricke@HIDDEN>,
 debian-release@HIDDEN, Paul Gevers <elbrus@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--QjrpsK2OUUiVbJpn
Content-Type: text/plain; charset=iso-8859-1
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

El 18/09/22 a las 07:57, Lucas Nussbaum escribi=F3:
> Hi,
>=20
> On 16/09/22 at 21:35 +0200, Paul Gevers wrote:
> > Hi Santiago,
> >=20
> > On 15-09-2022 09:26, Paul Gevers wrote:
> > > I am trying to schedule autopkgtests in unstable on amd64 for all sou=
rce
> > > packages that have one.
> >=20
> > All results are now in. Only several test failed due this warning: the =
known
> > dpkg and cjet and the newly found nagios-plugins-contrib, logcheck and
> > xautolock (see links below).
> >=20
> > > Lucas, are you in the position to do an archive rebuild to check for =
the
> > > grep warnings (see full history at [1]). When you submit bugs, can you
> > > please file them as important, as apparently upstream wants to turn
> > > these warnings into failures in the future, but in Debian Santiago is
> > > going to silence the warning soon, so FTBFS due to this isn't an RC
> > > problem on the short term.
> > >=20
> > > Santiago, please keep the grep with warning in unstable until either =
all
> > > tests are finished or we abort this plan.
> >=20
> > To be honest, without bug 1019326 in ucf and bug 1019725 in libtool fix=
ed,
> > I'm not sure how much value an archive rebuild would be at this stage.
> >=20
> > So I think it would be good to silence the warning now in Debian. As
> > discussed before, ideally with a way to turn it on (or make it error) s=
uch
> > that we can do archive wide QA before the behavior is changed to error =
out
> > upstream. I can understand it if you want to wait with deploying that
> > optional behavior until upstream has implemented it.

Dear grep developers,

Just to say that I am also in favor to *temporarily* silence the stray-\
warnings. In the Debian context, the most problematic are the failing
autopkgtests, since they could block the transition of a package from
unstable to testing. Even if there are a few packages, as listed above
(including dpkg), that currently have a failing test due to the stray-\
warning, it would be great to avoid new autopkgtests fails due to that.

Also, as you can read below, there are 4235 packages including the
warning in their build logs. Funnily, grep is also in the list :-)

> I did an archive rebuild (not specifically for this). Grepping the logs,
> the following 4235 packages exhibit the warning.
>=20
[snip]
> gregwar-captcha grep gretl gri grisbi groff gromacs groonga grub2 grub
[snip]

You can find the warnings in e.g. the last amd64 3.8-2 build:
https://buildd.debian.org/status/fetch.php?pkg=3Dgrep&arch=3Damd64&ver=3D3.=
8-2&stamp=3D1662998047&raw=3D0

(Thanks Lucas for running the archive rebuild!)

Hopefully, these are "just warnings" for now. I do agree the erroneous
patterns should be fixed, but I would prefer if we could have a smoother
transition before they result in grep errors.
As proposed by Paul Gevers, could you please consider silencing the
stray-\ warning for now, and adding a mechanism (envvar or option, as
you prefer) to enable them?

Cheers,

 -- S

--QjrpsK2OUUiVbJpn
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iHUEABYIAB0WIQRZVjztY8b+Ty43oH1itBCJKh26HQUCYyhhRQAKCRBitBCJKh26
HQK9AQDGzfkk0u/mePXi+AyNnop4V4u+OBAVpVYeafw20iEqyQD+KMJ2USh9Wu0b
ulFu2sh2xq2JS4CahlquyiUq03UPMQ4=
=GI6Y
-----END PGP SIGNATURE-----

--QjrpsK2OUUiVbJpn--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 16 Sep 2022 17:13:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 16 13:13:06 2022
Received: from localhost ([127.0.0.1]:44140 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oZEtl-000596-NS
	for submit <at> debbugs.gnu.org; Fri, 16 Sep 2022 13:13:05 -0400
Received: from mail-lf1-f42.google.com ([209.85.167.42]:38664)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1oZEtj-00058c-9a
 for 57604 <at> debbugs.gnu.org; Fri, 16 Sep 2022 13:13:04 -0400
Received: by mail-lf1-f42.google.com with SMTP id f14so35632117lfg.5
 for <57604 <at> debbugs.gnu.org>; Fri, 16 Sep 2022 10:13:03 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date;
 bh=i/NX9mkNLDB4TTfEB/WSAQWlVCGq36uLw81+nty9Cgk=;
 b=BiWEOhgmICBpTsRWqgYIwbz5bI3S9oCrOhaEdidDcYAsRTPrQcbVT7cmETQnOrMBUW
 c2AoZw751uTfNUXCJW+C7UzGZsZJl5uQl5SnsiuI/up2QDFolOE1gYtsvry6RSv0JKc+
 2d74Z/z+M/r1ceeFhYWliFFocijjZ8d+Ou6PzLrZgfaJ8Sy8HJkoNg317x0PDbB2ar31
 h8UQJhkZpREYr8wEANhXFTZC1EhXrzK33q55qfUou0v6KZk4vNYv2pOnDKMtdOskyJca
 WTCQctKZSt1u4bYWDieWWDgcuXP75yQ6q8JUBU2WtKsadKBwab3XuT4geTRvTxRaS0I4
 tbdQ==
X-Gm-Message-State: ACrzQf1ICT0qnw/vLKC6EK88Yq7F5oIr33sIiYoHPJz/tXB8iiBwq7Tc
 X7lCq77Pqg9Ufg51BdbrClVrBRPV+NG+aWYJZyI=
X-Google-Smtp-Source: AMsMyM6KKGr4Z5sst0CMCTzjpuH2GePAl+6x7b50g3g4BrfBYT8HbgcQA1XY0F+DJm6kdSzhc6XwYiUrGh0MGaZyTm4=
X-Received: by 2002:a05:6512:10d3:b0:499:cce2:37a8 with SMTP id
 k19-20020a05651210d300b00499cce237a8mr1913529lfg.169.1663348377201; Fri, 16
 Sep 2022 10:12:57 -0700 (PDT)
MIME-Version: 1.0
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
 <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
 <YyPLwSD8MMBZPw85@HIDDEN>
 <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
 <87a66z8ic8.fsf@HIDDEN>
In-Reply-To: <87a66z8ic8.fsf@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Fri, 16 Sep 2022 10:12:44 -0700
Message-ID: <CA+8g5KGgMom_+3XmE5jG_BSzse-WBRM2h5raZ-rPbpVJ+cjgNw@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
To: Simon Josefsson <simon@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 57604
Cc: Paul Eggert <eggert@HIDDEN>, Guillem Jover <guillem@HIDDEN>,
 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On Fri, Sep 16, 2022 at 8:12 AM Simon Josefsson <simon@HIDDEN> wrote:
> Jim Meyering <jim@HIDDEN> writes:
>
> > This would be an envvar for which we do not commit to any level of
> > support in future releases.
>
> Would the envvar be documented?  Would it be a deprecated feature, with
> a removal plan?  It seems we traded removing [ef]grep into introducing
> new unsupported features which feels a bit unsatisfying...
>
> How about saying that the envvar, together with all remaining traces of
> [ef]grep references will be removed in 2025?
>
> The point with the excercise was (at least to me) to remove complexity,
> but it seems we will have to wait some more until that can happen.

Hi Simon,
I agree that adding temporary complexity (and then
documenting/announcing it) to aid in the transition feels wrong.
I'm still not sure, but if we were to add such things, they would most
definitely come with a planned removal date, likely before 2025.




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 16 Sep 2022 15:11:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 16 11:11:47 2022
Received: from localhost ([127.0.0.1]:43973 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oZD0M-000271-Ra
	for submit <at> debbugs.gnu.org; Fri, 16 Sep 2022 11:11:47 -0400
Received: from uggla.sjd.se ([178.174.241.107]:56470)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <simon@HIDDEN>) id 1oZD0I-00026m-AO
 for 57604 <at> debbugs.gnu.org; Fri, 16 Sep 2022 11:11:45 -0400
DKIM-Signature: v=1; a=ed25519-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=ed2110; h=Content-Type:MIME-Version:Message-ID:In-Reply-To
 :Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding
 :Content-ID:Content-Description;
 bh=lW7iSNiDHcwCNGBYVNufMOssIPEE0QJhPUG8647wzTY=; t=1663341102; x=1664550702; 
 b=MrwhcKDmljwJtk91Ex6uEZnbzA3yzNv9/aDJb5Elv5wSV3yJQu0izOwXl+Q785jDu5F6gGya2y/
 y8He92+tcAA==;
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=rsa2110; h=Content-Type:MIME-Version:Message-ID:
 In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description;
 bh=lW7iSNiDHcwCNGBYVNufMOssIPEE0QJhPUG8647wzTY=; t=1663341102; x=1664550702; 
 b=MOgwHFZgnZAW0zh6CwJULPgG0yWoD/qaMhp88lXfK+rgGS+0FVBzMbcZKWUSp+HQB2NuTd3J/3r
 N3sa88ZqC3YGLaXv/nrSiDxUoV8NkyzsCvHp5y1RYkLFZJKTN6t0HEYdKUjje5hNLA0fpi1dO4i7V
 j9FKazuSiSzYXPO8pnOeGSjx+KEUn+nj9zb9Xw2v605OD/09iIB/zG4RN+FMCGEtrodl57aVPeAwh
 30yE7R195iEb2HPWnY9zfYpTLjDPAwbkLH1mdjfdrSGAh+uaMG0Vp0pr+1DTCWUTaLrKUzVMMQIqF
 pp6SoFF24VZM/xlISVZ4Dg/SCBTM02QTi3gNa1uaSUcxozFXqlepZj9V+6ifXP2Py+xxtv6AIBH27
 i04TeHfv17tZuHiyKEm8hntq4o2YINm1b0wyY2ikXRwcI7DQgHW2mD7KABAnV43GkGr6FepeS;
Received: from h-82-196-111-25.na.cust.bahnhof.se ([82.196.111.25]:60252
 helo=latte) by uggla.sjd.se with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94.2)
 (envelope-from <simon@HIDDEN>)
 id 1oZD0C-00D0sz-9Y; Fri, 16 Sep 2022 17:11:36 +0200
From: Simon Josefsson <simon@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
 <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
 <YyPLwSD8MMBZPw85@HIDDEN>
 <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
OpenPGP: id=B1D2BD1375BECB784CF4F8C4D73CF638C53C06BE;
 url=https://josefsson.org/key-20190320.txt
X-Hashcash: 1:22:220916:jim@HIDDEN::j66egixqt+aSlcwN:8Xk+
X-Hashcash: 1:22:220916:guillem@HIDDEN::z/LKkScOTQzHEy1j:Rt/c
X-Hashcash: 1:22:220916:eggert@HIDDEN::1VVKLgbcyj0Ifnku:SP6/
X-Hashcash: 1:22:220916:57604 <at> debbugs.gnu.org::+P1bm63wwKqQdUTj:IZQ8
Date: Fri, 16 Sep 2022 17:11:35 +0200
In-Reply-To: <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
 (Jim Meyering's message of "Fri, 16 Sep 2022 01:30:16 -0700")
Message-ID: <87a66z8ic8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57604
Cc: Paul Eggert <eggert@HIDDEN>, Guillem Jover <guillem@HIDDEN>,
 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Jim Meyering <jim@HIDDEN> writes:

> This would be an envvar for which we do not commit to any level of
> support in future releases.

Would the envvar be documented?  Would it be a deprecated feature, with
a removal plan?  It seems we traded removing [ef]grep into introducing
new unsupported features which feels a bit unsatisfying...

How about saying that the envvar, together with all remaining traces of
[ef]grep references will be removed in 2025?

The point with the excercise was (at least to me) to remove complexity,
but it seems we will have to wait some more until that can happen.

/Simon

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIoEARYIADIWIQSjzJyHC50xCrrUzy9RcisI/kdFogUCYySSJxQcc2ltb25Aam9z
ZWZzc29uLm9yZwAKCRBRcisI/kdFoo5tAQCcyGA/tQBAQpel7nAoZ5LIszTz11iB
VSC/YC7m6LDtTAD/ZlhHAg+q+6GZlkYKQeJ/Znq7WKTWoRoS2sQh5hvLAwA=
=eY8b
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 16 Sep 2022 12:15:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 16 08:15:46 2022
Received: from localhost ([127.0.0.1]:42019 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oZAG2-0005Mn-6D
	for submit <at> debbugs.gnu.org; Fri, 16 Sep 2022 08:15:46 -0400
Received: from master.debian.org ([82.195.75.110]:46890)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <guillem@HIDDEN>) id 1oZAFx-0005CG-KI
 for 57604 <at> debbugs.gnu.org; Fri, 16 Sep 2022 08:15:43 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=debian.org; 
 s=smtpauto.master;
 h=In-Reply-To:Content-Type:MIME-Version:References:
 Message-ID:Subject:Cc:To:From:Date:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description;
 bh=Zh+YkbrCRp6YM4ygVhfaz19+UaSDr+6jdS3/uboxKpI=; b=HcNIoy0CP/npA7BOXDNk7FfFn9
 eLW+V43l14sR6uY69P8YsoZrFcKhFQkNOgKfkUCLuWiAaaD3SvB8j/cAPlnIhH3ALOaaOAznxsDZT
 tPt8WVResfayo3cE8ZdmDuCJsu15XZBG8DtbOW4bYyvi58HufMqsj2p/WXlKC+ypTjVKfm6ch67vU
 hKcaVJhCrbRfFlEVkMGr2C9B2DNdApAKxxErVOUYN1NHUZPGg8DgIPKf2BkE99Qm/0I68fboNDVKR
 IdkJwWyv1dqbi+r4cLGhVt5KrKTwswu2oHy5c91dc8MwYP8dcl7ATakYpi3A9roqEWzSs2PHkO99h
 5zkjRw6Q==;
Received: from guillem by master.debian.org with local (Exim 4.94.2)
 (envelope-from <guillem@HIDDEN>)
 id 1oZAFr-008CHs-L7; Fri, 16 Sep 2022 12:15:35 +0000
Date: Fri, 16 Sep 2022 14:15:33 +0200
From: Guillem Jover <guillem@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <YyRo5V6lzy8Ksk2V@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
 <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
 <YyPLwSD8MMBZPw85@HIDDEN>
 <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57604
Cc: Paul Eggert <eggert@HIDDEN>, 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, 2022-09-16 at 01:30:16 -0700, Jim Meyering wrote:
> On Thu, Sep 15, 2022 at 9:28 PM Guillem Jover <guillem@HIDDEN> wrote:
> > It's true that most of those instances are probably not going to fail.
> > But what is definitely being affected are autopkgtests from Debian
> > packages for example. By default those consider any output to stderr
> > a signal to mark the test as failing. So the new grep failures are
> > causing unrelated tests to fail now.
> >
> > Some are going to be hard to fix locally, or quickly everywhere, for
> > example the one in libtool, as until it is fixed, relibtoolizing will
> > have not effect, and afterwards that will get fixed only as long as
> > the packaging always forcibly relibtoolizes (or autoreconfigures).
> > <https://bugs.debian.org/1019725>
> >
> >
> > As I've mentioned earlier, personally, I definitely want to be able to
> > see those kinds of warnings so that I can fix or change stuff I
> > maintain, or report bugs with patches. But unfortunately it seems this
> > is causing enough disruption that all the new warnings might end up
> > being disabled in Debian. I think it's been discussed earlier that
> > environment variables are not desired? But I think it would still be nice
> > to be able to control those warnings globally/externally, so that even
> > if say a project like Debian ends up disabling them, people can still
> > enable them to be able to diagnose and track those down.
> 
> Thanks for the feedback.
> 
> We may make a new release with two additions:
> - an envvar to control [ef]grep warnings, enabled by default
> - a configure-time option to make it disabled by default

Sorry if I was not more explicit, while the [ef]grep warnings seem to
be causing disruption, the warning affecting libtool is the one about
"stray \ before ". I'm not sure how the other new warnings (AFAIR there
are more?) are affecting things though, but it might be worth handling
all the newly introduced warnings in the same way?

(Debian's grep bug discussing this is <https://bugs.debian.org/1019724>.)

> This would be an envvar for which we do not commit to any level of
> support in future releases.

I think that would be perfectly fine as a transitional measure, yes.
Thanks for considering!

Regards,
Guillem




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 16 Sep 2022 08:30:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 16 04:30:38 2022
Received: from localhost ([127.0.0.1]:41577 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oZ6kA-00053j-3q
	for submit <at> debbugs.gnu.org; Fri, 16 Sep 2022 04:30:38 -0400
Received: from mail-lf1-f44.google.com ([209.85.167.44]:40792)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1oZ6k7-00053Q-CJ
 for 57604 <at> debbugs.gnu.org; Fri, 16 Sep 2022 04:30:36 -0400
Received: by mail-lf1-f44.google.com with SMTP id s6so23178623lfo.7
 for <57604 <at> debbugs.gnu.org>; Fri, 16 Sep 2022 01:30:35 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date;
 bh=/cCyGDzaGV/DvYP5LNga8fU3IzIM4TjtuMDQGuHQFHw=;
 b=M4t7oBDkmLiDX8aO71kQ71EGf4N+yAYYXh1+uNM6DFNvFq87a2FFURhIemu32BMxEA
 wFKULrkPN0ysxOpLEemHCoOJ95kEUsXwIk9tEDRMHdcYkIx9RIAHJV5hiS0v/IfL3hB0
 THOML8m3GPQxUaTkxxK4tXw5cWZZSUSSvspnikUagBCZI3E+hV7Y4GFAlQ+1uUcbSGtw
 1lAAYsxQB6JSO2NTXFKd4oxhBiJGgNb54wXltZdsa3QHpGWQJKd3Crfk3JLfKFc+OO39
 TjXt9yBJJbErbG2SR7hpjHLDGGZ6CFw1rSBjbowJWp0xy2ydBFzhxCVSdMBSVvxr3pmA
 qR1Q==
X-Gm-Message-State: ACrzQf27QVhvQymqEUGtYUmBBoViHgL3Ghwe8cK4sdfHgI3WsUEs8VdY
 q6ZeaO/lu4QVD1t84Dpe6F6H2R52C7bYJRcYjCw=
X-Google-Smtp-Source: AMsMyM4knIvIy7u5qmDINWo7UbTWo0DoTSt47xjCCB9rzS1wRoOsy/gIBmilXMynCaTN9Wc5QEclycFtS06ZE6xECOo=
X-Received: by 2002:a05:6512:6c8:b0:49a:1765:335d with SMTP id
 u8-20020a05651206c800b0049a1765335dmr1245302lff.29.1663317029309; Fri, 16 Sep
 2022 01:30:29 -0700 (PDT)
MIME-Version: 1.0
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
 <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
 <YyPLwSD8MMBZPw85@HIDDEN>
In-Reply-To: <YyPLwSD8MMBZPw85@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Fri, 16 Sep 2022 01:30:16 -0700
Message-ID: <CA+8g5KE4urDJjta5x6fKRH+V3RFQZO3USrE-WxVNmayVV9EM_Q@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
To: Guillem Jover <guillem@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 57604
Cc: Paul Eggert <eggert@HIDDEN>, 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On Thu, Sep 15, 2022 at 9:28 PM Guillem Jover <guillem@HIDDEN> wrote:
> On Fri, 2022-09-09 at 11:41:49 -0500, Paul Eggert wrote:
> > On 9/9/22 07:16, Guillem Jover wrote:
> > > There are now packages that fail to work such as
> > > apt-file (https://bugs.debian.org/1019329),
> >
> > From what I can see, that bug report doesn't say that apt-file fails to
> > work, only that apt-file issues a warning and then goes on to work.
>
> Ah, you are right, that might have coincided with a query I did that
> returned nothing then, sorry about that!
>
> > > Transitioning away from fgrep/egrep seems like it would be painful as
> > > that involves lots of upstream projects:
> >
> > I glanced at those, and didn't see any projects that will stop working, only
> > projects that will see annoying warnings. Admittedly I didn't look at all
> > the examples, but in the first page of
> > <https://codesearch.debian.net/search?q=fgrep&literal=1> (your first
> > citation) all the code examples should continue to work.
> >
> > Could you give examples of programs that actually stop working? That would
> > help us consider remedies.
>
> It's true that most of those instances are probably not going to fail.
> But what is definitely being affected are autopkgtests from Debian
> packages for example. By default those consider any output to stderr
> a signal to mark the test as failing. So the new grep failures are
> causing unrelated tests to fail now.
>
> Some are going to be hard to fix locally, or quickly everywhere, for
> example the one in libtool, as until it is fixed, relibtoolizing will
> have not effect, and afterwards that will get fixed only as long as
> the packaging always forcibly relibtoolizes (or autoreconfigures).
> <https://bugs.debian.org/1019725>
>
>
> As I've mentioned earlier, personally, I definitely want to be able to
> see those kinds of warnings so that I can fix or change stuff I
> maintain, or report bugs with patches. But unfortunately it seems this
> is causing enough disruption that all the new warnings might end up
> being disabled in Debian. I think it's been discussed earlier that
> environment variables are not desired? But I think it would still be nice
> to be able to control those warnings globally/externally, so that even
> if say a project like Debian ends up disabling them, people can still
> enable them to be able to diagnose and track those down.

Thanks for the feedback.

We may make a new release with two additions:
- an envvar to control [ef]grep warnings, enabled by default
- a configure-time option to make it disabled by default

This would be an envvar for which we do not commit to any level of
support in future releases.




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 16 Sep 2022 04:28:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 16 00:28:02 2022
Received: from localhost ([127.0.0.1]:41128 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oZ2xN-0006se-BM
	for submit <at> debbugs.gnu.org; Fri, 16 Sep 2022 00:28:01 -0400
Received: from master.debian.org ([82.195.75.110]:60168)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <guillem@HIDDEN>) id 1oYzn4-0007Qb-2C
 for 57604 <at> debbugs.gnu.org; Thu, 15 Sep 2022 21:05:10 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=debian.org; 
 s=smtpauto.master;
 h=In-Reply-To:Content-Type:MIME-Version:References:
 Message-ID:Subject:Cc:To:From:Date:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description;
 bh=owYVpQBwOnQv3ByCr3KumT5VCgL2Fb52hu6sUsHNFIE=; b=UFpLg6UfLvpXjGBh7+5orSxowJ
 qKgjzONmL9SItGM72g8dXX+JhwqPeUvOQ0dNZL5uEc586gEOa5uTHZTX/3hBtCSCcBMgG9pu4CwGD
 klknnLhgj8P56kQpaIRT6a8mdsk0+FYlFUA/1MEbGxgmGXsBzcOY87tDfZRi7W6xkjBr+21RRoOPj
 50WprtOR3VMxFQeXp6ey0tyGYKumFgMA+QE9LBkQuOE3So0SgsHXXgXL7gHSwIkpC/ecCk79uL0qP
 p12ZZfZjycoG0TIQEgUQOMvIyBiF+7wjlnfE7oTcvujs1vmJdUkWxhnbdw7MMj5GkFKZv2VuDd++j
 2A1/65DA==;
Received: from guillem by master.debian.org with local (Exim 4.94.2)
 (envelope-from <guillem@HIDDEN>)
 id 1oYzn1-007a11-3d; Fri, 16 Sep 2022 01:05:07 +0000
Date: Fri, 16 Sep 2022 03:05:05 +0200
From: Guillem Jover <guillem@HIDDEN>
To: Paul Eggert <eggert@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <YyPLwSD8MMBZPw85@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
 <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 57604
X-Mailman-Approved-At: Fri, 16 Sep 2022 00:27:55 -0400
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, 2022-09-09 at 11:41:49 -0500, Paul Eggert wrote:
> On 9/9/22 07:16, Guillem Jover wrote:
> > There are now packages that fail to work such as
> > apt-file (https://bugs.debian.org/1019329),
> 
> From what I can see, that bug report doesn't say that apt-file fails to
> work, only that apt-file issues a warning and then goes on to work.

Ah, you are right, that might have coincided with a query I did that
returned nothing then, sorry about that!

> > Transitioning away from fgrep/egrep seems like it would be painful as
> > that involves lots of upstream projects:
> 
> I glanced at those, and didn't see any projects that will stop working, only
> projects that will see annoying warnings. Admittedly I didn't look at all
> the examples, but in the first page of
> <https://codesearch.debian.net/search?q=fgrep&literal=1> (your first
> citation) all the code examples should continue to work.
> 
> Could you give examples of programs that actually stop working? That would
> help us consider remedies.

It's true that most of those instances are probably not going to fail.
But what is definitely being affected are autopkgtests from Debian
packages for example. By default those consider any output to stderr
a signal to mark the test as failing. So the new grep failures are
causing unrelated tests to fail now.

Some are going to be hard to fix locally, or quickly everywhere, for
example the one in libtool, as until it is fixed, relibtoolizing will
have not effect, and afterwards that will get fixed only as long as
the packaging always forcibly relibtoolizes (or autoreconfigures).
<https://bugs.debian.org/1019725>


As I've mentioned earlier, personally, I definitely want to be able to
see those kinds of warnings so that I can fix or change stuff I
maintain, or report bugs with patches. But unfortunately it seems this
is causing enough disruption that all the new warnings might end up
being disabled in Debian. I think it's been discussed earlier that
environment variables are not desired? But I think it would still be nice
to be able to control those warnings globally/externally, so that even
if say a project like Debian ends up disabling them, people can still
enable them to be able to diagnose and track those down.

Thanks,
Guillem




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 15 Sep 2022 13:57:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 15 09:57:34 2022
Received: from localhost ([127.0.0.1]:58794 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oYpMz-0008UV-S4
	for submit <at> debbugs.gnu.org; Thu, 15 Sep 2022 09:57:34 -0400
Received: from mx1.riseup.net ([198.252.153.129]:35826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <santiagorr@HIDDEN>) id 1oYpMx-0008UJ-VU
 for 57604 <at> debbugs.gnu.org; Thu, 15 Sep 2022 09:57:32 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx1.riseup.net (Postfix) with ESMTPS id 4MSzKd6FMlzDsBZ;
 Thu, 15 Sep 2022 13:57:25 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1663250246; bh=GTFVsVgLzX76RabKLa7hErvxzTtevsQXSXKyH0MHmvc=;
 h=Date:From:To:Cc:Subject:References:In-Reply-To:From;
 b=cQRQW4a9Ba5Zj1ejIbTvggYnUK5ssWr0PJkGVr2sdWuslvZ7hNgbtm3Yx3PQF/lIW
 XItIVL04ivsIN8NUclwOX1JBNl2cLwh+wLrVc6yvbNWVUgqHs9ovP1qIyaLvCaoK0e
 7kWiE4fvGYM2tDbNS38WK9IEUOwFkj7/W73tRb9Y=
X-Riseup-User-ID: 0AB0C2AB89FF8FC44EFB0D6AC6626004F9F77B567BD5639272ACC6B67FB21894
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4MSzKc6Z47z5vP3;
 Thu, 15 Sep 2022 13:57:24 +0000 (UTC)
Date: Thu, 15 Sep 2022 15:57:22 +0200
From: Santiago Ruano =?iso-8859-1?Q?Rinc=F3n?= <santiagorr@HIDDEN>
To: 57604 <at> debbugs.gnu.org
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <YyMvQp0KxLHlp1zC@bartik>
References: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
 <202209082301.288N11Ta020587@HIDDEN>
 <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
 <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
 <202209131859.28DIxiXR028692@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature"; boundary="HKMZg6AUPI84O7ys"
Content-Disposition: inline
In-Reply-To: <202209131859.28DIxiXR028692@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57604
Cc: sam@HIDDEN, arnold@HIDDEN, jim@HIDDEN, karl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--HKMZg6AUPI84O7ys
Content-Type: text/plain; charset=iso-8859-1
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

El 13/09/22 a las 12:59, arnold@HIDDEN escribi=F3:
> Sam <sam@HIDDEN> wrote:
>=20
> > I honestly think at this point, it'd be better to just deem them GNU
> > extensions.
>=20
> I agree with this, wholeheartedly. FWIW.
>=20
> Arnold

FWIW, {e,f}grep have been reintroduced in Debian with grep 3.8-2.

Now, the stray \ warning is causing trouble. libtool has a problematic
grep \-L:
https://sources.debian.org/src/dpkg/1.21.9/m4/libtool.m4/#L6472
which is embedded in an important number of packages:
https://codesearch.debian.net/search?q=3DConfigured+with%3A%22+%7C+%24GREP+=
%22+%5C-L&perpkg=3D1

Jochen Sprickerhof has already reported the problem in libtool,
including a patch:
https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=3D1019725
https://lists.gnu.org/archive/html/libtool-patches/2022-09/msg00001.html
but it will take a lot of time before all of the concerned packages get
a fixed libtool.

I am willing to temporarily silent those warnings, once the affected
packages have been identified, so we can submit bugs and fix them.
See: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=3D1019724

Cheers,

 -- Santiago

--HKMZg6AUPI84O7ys
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iHUEABYIAB0WIQRZVjztY8b+Ty43oH1itBCJKh26HQUCYyMvOgAKCRBitBCJKh26
HSB9AP9uZYqYBVocw1UF4pu++r9RtJfbzgHBtuyYCgHJI8amEwEA1aaBRSI9WMjG
v7T+24/ZZNko0y3r6ZOy+1M2FaNCvwY=
=cYhs
-----END PGP SIGNATURE-----

--HKMZg6AUPI84O7ys--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 13 Sep 2022 19:00:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 13 15:00:13 2022
Received: from localhost ([127.0.0.1]:52919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oYB8n-0007rc-AV
	for submit <at> debbugs.gnu.org; Tue, 13 Sep 2022 15:00:13 -0400
Received: from freefriends.org ([96.88.95.60]:55486)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arnold@HIDDEN>) id 1oYB8l-0007rT-Vb
 for 57604 <at> debbugs.gnu.org; Tue, 13 Sep 2022 15:00:12 -0400
X-Envelope-From: arnold@HIDDEN
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 28DIxjln028693
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT); 
 Tue, 13 Sep 2022 12:59:46 -0600
Received: (from arnold@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 28DIxiXR028692;
 Tue, 13 Sep 2022 12:59:44 -0600
From: arnold@HIDDEN
Message-Id: <202209131859.28DIxiXR028692@HIDDEN>
X-Authentication-Warning: frenzy.freefriends.org: arnold set sender to
 arnold@HIDDEN using -f
Date: Tue, 13 Sep 2022 12:59:44 -0600
To: sam@HIDDEN, jim@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
 <202209082301.288N11Ta020587@HIDDEN>
 <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
 <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
In-Reply-To: <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
User-Agent: Heirloom mailx 12.5 7/5/10
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org, karl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Sam <sam@HIDDEN> wrote:

> I honestly think at this point, it'd be better to just deem them GNU
> extensions.

I agree with this, wholeheartedly. FWIW.

Arnold




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 11 Sep 2022 22:56:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 11 18:56:45 2022
Received: from localhost ([127.0.0.1]:43722 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oXVsb-0002je-5W
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2022 18:56:45 -0400
Received: from freefriends.org ([96.88.95.60]:47474)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oXVsZ-0002jV-0t
 for 57604 <at> debbugs.gnu.org; Sun, 11 Sep 2022 18:56:43 -0400
X-Envelope-From: karl@HIDDEN
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 28BMuaQf013340
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT); 
 Sun, 11 Sep 2022 16:56:36 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 28BMuaTp013339;
 Sun, 11 Sep 2022 16:56:36 -0600
Date: Sun, 11 Sep 2022 16:56:36 -0600
Message-Id: <202209112256.28BMuaTp013339@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: jim@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

    AFAIK, these new warnings cause no malfunction.

Only if you've already changed your entire world not to use [ef]grep.
Then of course the warnings have no effect :).

Otherwise, they certainly do. I have scripts that run [ef]hundreds of
times (in loops, on lots of files).  grep is fundamental to shell script
programming, after all. Thus unconditional-on-every-invocation the
warning renders the script unusable.

In other cases, outputting to stderr changes the behavior of the script,
as Sam wrote in msg #62.

See also msg #53 in this bug report:
  https://debbugs.gnu.org/cgi/bugreport.cgi?bug=57604#53
for effects far worse than anything on my own little systems.

In general, when a program has behaved in a given way for many years,
and you change the behavior, it just seems fundamental to me to provide
a way for users to get the previous behavior. GNU has been known for
backward compatibility and user-friendliness.

    Wouldn't it be better to fix the roots of the problem 

Well, we differ about "the root of the problem". To me, the original
deprecation was the mistake. I would have argued against it if I'd known
about it, but I missed it. Although I doubt you would have been swayed
by anything I could say, given this thread.

But never mind that, you're hardly likely to change your mind now. Thus
all I'm asking for is a way for [ef]grep to keep working
(forever). There is no harm in the programs. A configure-time option
would be fine.

    personal scripts or on the command line, create your wrapper script
    or alias/function.

As I said before, obviously these workarounds are trivial to do on a
person-by-person basis. Less so for whole systems.

But the general point is, why must you force work on the rest of the
world? In the real world (as opposed to the POSIX_ME_HARDER world that
you apparently want everyone to live in), the warning decreases
portability: scripts that worked before no longer work. There is nothing
forcing you to give that warning unconditionally.  Why is this in the
spirit of GNU? As I wrote from the coding standards ...

If distros choose to stupidly remove [ef]grep, that's their (and their
users') problem. There's nothing that says you need to contribute to it,
and plenty that says you shouldn't. -k




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Sep 2022 20:58:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 11 16:58:40 2022
Received: from localhost ([127.0.0.1]:43680 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oXU2J-0008Gl-Qs
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:58:40 -0400
Received: from lists.gnu.org ([209.51.188.17]:53570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bruce.dubbs@HIDDEN>) id 1oXU2I-0008Gc-Ij
 for submit <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:58:39 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:53806)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <bruce.dubbs@HIDDEN>)
 id 1oXU2I-0004uW-D1
 for bug-grep@HIDDEN; Sun, 11 Sep 2022 16:58:38 -0400
Received: from mail-oa1-x29.google.com ([2001:4860:4864:20::29]:46863)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <bruce.dubbs@HIDDEN>)
 id 1oXU2G-0007WX-HO
 for bug-grep@HIDDEN; Sun, 11 Sep 2022 16:58:38 -0400
Received: by mail-oa1-x29.google.com with SMTP id
 586e51a60fabf-12b542cb1d3so8743983fac.13
 for <bug-grep@HIDDEN>; Sun, 11 Sep 2022 13:58:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=content-transfer-encoding:in-reply-to:from:references:to
 :content-language:subject:user-agent:mime-version:date:message-id
 :from:to:cc:subject:date;
 bh=D8cpat6vbKTEgJN0HomypQPYszO8k1YtJlrl35sJOR8=;
 b=Y53qWoqqGznV0hn7uPV3toZSu2yKEhOktplFJKSL8mtxw0UaRXdSQgGcRDtnkm3jQO
 AnqpJ3pfsqvw/YzJ0A4qmv+j4AnDKIaJGk0O0s1PF10MYrlqEwV29psfjiHeFNgfxSTx
 8Hy+8cnnzx+ksCQdPpkG4LwOehMBlDMLu5KmVZ8Ydnbowum+LckrR87LO9b7hy+VRUYS
 Z1etUEznttbhSKsVnl00K93HeAg9bn87sICNtxgzIrGMtI3f550VPMQ5VVRP+d2HZjRb
 ikDuhnd+aCZzZXmVaaQSYiMcpvcVjgkX+exUQYiWrWxoz0soKBmR8GODSPF2GCudqviI
 UBYg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:in-reply-to:from:references:to
 :content-language:subject:user-agent:mime-version:date:message-id
 :x-gm-message-state:from:to:cc:subject:date;
 bh=D8cpat6vbKTEgJN0HomypQPYszO8k1YtJlrl35sJOR8=;
 b=KW3IlkG2R0nwFBE/kBxxSzt2kQyrhpEMqsX7J6GDZUKk540WUKm+JC3dhIQ2V8BvBz
 XA0du3WVuLhS6saV9Jpxpbfg+r41LJ5q+P2Mst4EY53SxemVf990dOpys0pL+AQLnioD
 3+EdbD3pHGXXEEekz7lRuf6UqRZekPeg8CcD8df3UzuAM3Ha3iHxIspfCDE++XwVmqKC
 FFjqqdg97hNqc40c8p3T0kg/3KRcmKQssQkCzSYOH+VCM6jHdt1AcRAte1jnvPyplbbA
 vTWi6l//S0/BboLQnTByVSu96HFriDWWqPxbK7da5oMkfyK4PoS52D8BUSMWpreLnO27
 Fo7Q==
X-Gm-Message-State: ACgBeo1RyjbstUkqiyoup/WDD0Kq0uupOjk13Hb+VuibVgoiTvJovVb1
 EBR7uC3NBLFD2SR0qhu8otT/i598cbQ=
X-Google-Smtp-Source: AA6agR690oCRKsCy6PEVXGhYdlc7lerGySQ4gOtYdpc2/CzZaZOTjJQ8Edp8pioGJt8hD0L8/lhOkA==
X-Received: by 2002:a05:6870:8a29:b0:126:f6e:dd5b with SMTP id
 p41-20020a0568708a2900b001260f6edd5bmr9728662oaq.226.1662929914956; 
 Sun, 11 Sep 2022 13:58:34 -0700 (PDT)
Received: from [192.168.0.92] (cpe-70-94-157-206.satx.res.rr.com.
 [70.94.157.206]) by smtp.gmail.com with ESMTPSA id
 o8-20020a9d4048000000b006370c0e5be0sm3576771oti.48.2022.09.11.13.58.34
 for <bug-grep@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Sun, 11 Sep 2022 13:58:34 -0700 (PDT)
Message-ID: <e1b026e9-f6a7-174a-79e9-e73c77c11eb9@HIDDEN>
Date: Sun, 11 Sep 2022 15:58:33 -0500
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.10.0
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Content-Language: en-US
To: bug-grep@HIDDEN
References: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
 <202209082301.288N11Ta020587@HIDDEN>
 <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
 <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
From: Bruce Dubbs <bruce.dubbs@HIDDEN>
In-Reply-To: <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
Received-SPF: pass client-ip=2001:4860:4864:20::29;
 envelope-from=bruce.dubbs@HIDDEN; helo=mail-oa1-x29.google.com
X-Spam_score_int: -61
X-Spam_score: -6.2
X-Spam_bar: ------
X-Spam_report: (-6.2 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 NICE_REPLY_A=-4.101, RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001, T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On 9/11/22 14:45, Sam wrote:
> 
> 
>> On 11 Sep 2022, at 21:41, Jim Meyering <jim@HIDDEN> wrote:
>>
>> On Thu, Sep 8, 2022 at 4:01 PM Karl Berry <karl@HIDDEN> wrote:
>>> Hi Jim,
>>>
>>>     Some must care about portability,
>>>
>>> Certainly agreed. Even I do, sometimes :). But that does not mean
>>> everyone needs to, in every situation.  As I said, I fail to understand
>>> the benefit of making the warning unconditional.
>>>
>>> So far as I can see, it's also against GNU principles, as I wrote,
>>> though evidently you don't agree.
>>>
>>>     and these warnings help them do a better job.
>>>
>>> When people want extreme POSIX compliance, they should set
>>> POSIXLY_CORRECT. That's what it's there for, and that's when I think the
>>> warnings should be issued, as I said at the beginning.
>>>
>>> But since Paul rejected that, ok, a different variable that lets us turn
>>> them off (GREPWARNINGS=efgrepok or whatever) would at least provide some
>>> palliation. I don't understand why you two are opposed to this simple
>>> remediation.
>>>
>>>     As Gary mentioned above, it's easy to disable them.
>>>
>>> Obviously it is trivial to edit the scripts or have a different version
>>> in PATH for my own machine(s).  But those are no substitute for having a
>>> supported way to use the distributed [ef]grep without warnings.
>>>
>>>     I would argue that it is even more important to retain these
>>>     stray-backslash warnings, because they tend to highlight real bugs.
>>>
>>> "tend" being the key word there. But anyway, I see your point, and won't
>>> argue that one further, since the efgrep warnings are what's causing me
>>> the agony. -k
>>
>> Hi Karl,
>>
>> It would help if you could point to some malfunction.
> 
> We've hit one malfunction in Gentoo: https://bugs.gentoo.org/868384.
> 
> A program was using libgcrypt-config via CMake and ended up
> failing because of the warnings.
> 
> (The program's usage is IMO ill-advised and it should use pkg-config,
> but that's beside the point).
> 
>>
>> Consider the alternative.
>>
>> Should we release a new version of grep that provides a documented way
>> (say a configure-time option) to disable a warning about a
>> long-deprecated feature so you don't have to manually tweak the
>> four-line fgrep and egrep scripts? AFAIK, these new warnings cause no
>> malfunction.
>>
>> Wouldn't it be better to fix the roots of the problem rather than
>> piling another kludge on top to disable the annoying warnings? Think
>> about the next steps: when more and more distros cease to distribute
>> the egrep and fgrep crutches, what will people do? Eventually, we'll
>> all break the habit, at least in scripts. If you want to use it in
>> personal scripts or on the command line, create your wrapper script or
>> alias/function.
>>
> 
> I honestly think at this point, it'd be better to just deem them GNU
> extensions.

After discussing this a bit in the LFS community, we tend to agree.  For us in the 
'from source' community, editing two short scripts is pretty trivial, but it really
shouldn't be needed.

   -- Bruce





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 11 Sep 2022 20:45:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 11 16:45:54 2022
Received: from localhost ([127.0.0.1]:43661 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oXTpy-0007gY-7U
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:45:54 -0400
Received: from supercat.cmpct.info ([71.19.146.230]:41486)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <sam@HIDDEN>) id 1oXTpw-0007gN-Jv
 for 57604 <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:45:53 -0400
Received: from smtpclient.apple (unknown [82.8.138.118])
 by supercat.cmpct.info (Postfix) with ESMTPSA id 3EC243FC3A;
 Sun, 11 Sep 2022 20:45:50 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cmpct.info;
 s=default; t=1662929150;
 bh=baq9siT6N4Z2aToSYkldjQ/OL09Jgnh4dfhlvRvWvDQ=;
 h=Subject:From:In-Reply-To:Date:Cc:References:To;
 b=J2rWJ9rwpFlQ/cTwkDjScF65z8itZ9RB8vQb4Lq0sOFAtLWJEXS1A3K0qYJBosvAx
 WKOPP1xUJ/dLp3UUnUJGwBjoLnuOxMsv+Qs6DmwFq6UvHEzcS5S/sHcUKO87vPbxYd
 VZ7QGCe1QZUCfTVgdtQCsLlz3SprA5ijUf+tY54c=
Content-Type: multipart/signed;
 boundary="Apple-Mail=_76491153-915F-4C8F-AFDC-06C8ACDAA6C0";
 protocol="application/pgp-signature"; micalg=pgp-sha512
Mime-Version: 1.0 (Mac OS X Mail 16.0 \(3696.120.41.1.1\))
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
From: Sam <sam@HIDDEN>
In-Reply-To: <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
Date: Sun, 11 Sep 2022 21:45:47 +0100
Message-Id: <9736C7E1-419E-45DE-8A2E-48FB90D95711@HIDDEN>
References: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
 <202209082301.288N11Ta020587@HIDDEN>
 <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
To: Jim Meyering <jim@HIDDEN>
X-Mailer: Apple Mail (2.3696.120.41.1.1)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org, Karl Berry <karl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--Apple-Mail=_76491153-915F-4C8F-AFDC-06C8ACDAA6C0
Content-Transfer-Encoding: 7bit
Content-Type: text/plain;
	charset=us-ascii



> On 11 Sep 2022, at 21:41, Jim Meyering <jim@HIDDEN> wrote:
> 
> On Thu, Sep 8, 2022 at 4:01 PM Karl Berry <karl@HIDDEN> wrote:
>> Hi Jim,
>> 
>>    Some must care about portability,
>> 
>> Certainly agreed. Even I do, sometimes :). But that does not mean
>> everyone needs to, in every situation.  As I said, I fail to understand
>> the benefit of making the warning unconditional.
>> 
>> So far as I can see, it's also against GNU principles, as I wrote,
>> though evidently you don't agree.
>> 
>>    and these warnings help them do a better job.
>> 
>> When people want extreme POSIX compliance, they should set
>> POSIXLY_CORRECT. That's what it's there for, and that's when I think the
>> warnings should be issued, as I said at the beginning.
>> 
>> But since Paul rejected that, ok, a different variable that lets us turn
>> them off (GREPWARNINGS=efgrepok or whatever) would at least provide some
>> palliation. I don't understand why you two are opposed to this simple
>> remediation.
>> 
>>    As Gary mentioned above, it's easy to disable them.
>> 
>> Obviously it is trivial to edit the scripts or have a different version
>> in PATH for my own machine(s).  But those are no substitute for having a
>> supported way to use the distributed [ef]grep without warnings.
>> 
>>    I would argue that it is even more important to retain these
>>    stray-backslash warnings, because they tend to highlight real bugs.
>> 
>> "tend" being the key word there. But anyway, I see your point, and won't
>> argue that one further, since the efgrep warnings are what's causing me
>> the agony. -k
> 
> Hi Karl,
> 
> It would help if you could point to some malfunction.

We've hit one malfunction in Gentoo: https://bugs.gentoo.org/868384.

A program was using libgcrypt-config via CMake and ended up
failing because of the warnings.

(The program's usage is IMO ill-advised and it should use pkg-config,
but that's beside the point).

> 
> Consider the alternative.
> 
> Should we release a new version of grep that provides a documented way
> (say a configure-time option) to disable a warning about a
> long-deprecated feature so you don't have to manually tweak the
> four-line fgrep and egrep scripts? AFAIK, these new warnings cause no
> malfunction.
> 
> Wouldn't it be better to fix the roots of the problem rather than
> piling another kludge on top to disable the annoying warnings? Think
> about the next steps: when more and more distros cease to distribute
> the egrep and fgrep crutches, what will people do? Eventually, we'll
> all break the habit, at least in scripts. If you want to use it in
> personal scripts or on the command line, create your wrapper script or
> alias/function.
> 

I honestly think at this point, it'd be better to just deem them GNU
extensions.

Best,
sam


--Apple-Mail=_76491153-915F-4C8F-AFDC-06C8ACDAA6C0
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment;
	filename=signature.asc
Content-Type: application/pgp-signature;
	name=signature.asc
Content-Description: Message signed with OpenPGP

-----BEGIN PGP SIGNATURE-----

iNUEARYKAH0WIQQlpruI3Zt2TGtVQcJzhAn1IN+RkAUCYx5I+18UgAAAAAAuAChp
c3N1ZXItZnByQG5vdGF0aW9ucy5vcGVucGdwLmZpZnRoaG9yc2VtYW4ubmV0MjVB
NkJCODhERDlCNzY0QzZCNTU0MUMyNzM4NDA5RjUyMERGOTE5MAAKCRBzhAn1IN+R
kK+lAP9hwanEVOzXmyTuS0hOhK6SMBWaOjZlMJs2tRr7SEjJ3gEA6XFBKRbqzVyx
aPMf+mLFLlhpw/iUkH+12pEwaiUpKQE=
=Sfrt
-----END PGP SIGNATURE-----

--Apple-Mail=_76491153-915F-4C8F-AFDC-06C8ACDAA6C0--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 11 Sep 2022 20:41:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 11 16:41:43 2022
Received: from localhost ([127.0.0.1]:43657 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oXTlv-0007Z9-EM
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:41:43 -0400
Received: from mail-lj1-f179.google.com ([209.85.208.179]:35335)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1oXTlt-0007Yu-D4
 for 57604 <at> debbugs.gnu.org; Sun, 11 Sep 2022 16:41:41 -0400
Received: by mail-lj1-f179.google.com with SMTP id 9so7469718ljr.2
 for <57604 <at> debbugs.gnu.org>; Sun, 11 Sep 2022 13:41:41 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date;
 bh=DswYoG0QBEieSAfSHBVcGQqmMqORr6sJWYR7ruRXV00=;
 b=6iwekA/3SGyR3amXcsGA0Kcpv5V8ABHomzfeFuZhBHN/Vq2UzOlQliAfI1qWmdhSCR
 vhFKU2tAbgAkUaeRtNcf9pgKwxFVmkWVVxE8uJykjmwNVAKnzie80Y3s13utXB1P/a7C
 wFVeqLAAOh8GCW+99lRY8McmD/JZ+CcxFGMLW3ioczAYd9u3V5jukNfTf05ywwHFUx+N
 85PjZa3EY/oKQ5LrLsTA3qONvUN/BwhCCHBDYltU0EBtODz2wdLGNTDUtX5PzQt1IC1I
 zEHHae46QL8FWMeCRKwev87apQ3piwYVmdvYQzeZVs8WKCXsFPksp6HK9fhvTI2eukeV
 2mJQ==
X-Gm-Message-State: ACgBeo0jBI/glXU0V/lpn4gy7JIubPpoJ9+fspr/bAj1VRoDcW2rJs+O
 vj0cwkBPmuNdCu0THU8+RvAik//Z/bLMWTv4x10=
X-Google-Smtp-Source: AA6agR7ccrDsibi1kBHFnrI4gwrjExCArxRJdDQtS+1ix8mG3wBpLifaUKu6EfvBuksZFpBW+bNMlq4jBKtlNxQIQPY=
X-Received: by 2002:a05:651c:88b:b0:261:ba8e:717a with SMTP id
 d11-20020a05651c088b00b00261ba8e717amr6783485ljq.401.1662928895227; Sun, 11
 Sep 2022 13:41:35 -0700 (PDT)
MIME-Version: 1.0
References: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
 <202209082301.288N11Ta020587@HIDDEN>
In-Reply-To: <202209082301.288N11Ta020587@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Sun, 11 Sep 2022 13:41:22 -0700
Message-ID: <CA+8g5KF05EcSpP662avc6i=hksV57W1bE_pxok2M6dcGUEnvxQ@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
To: Karl Berry <karl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On Thu, Sep 8, 2022 at 4:01 PM Karl Berry <karl@HIDDEN> wrote:
> Hi Jim,
>
>     Some must care about portability,
>
> Certainly agreed. Even I do, sometimes :). But that does not mean
> everyone needs to, in every situation.  As I said, I fail to understand
> the benefit of making the warning unconditional.
>
> So far as I can see, it's also against GNU principles, as I wrote,
> though evidently you don't agree.
>
>     and these warnings help them do a better job.
>
> When people want extreme POSIX compliance, they should set
> POSIXLY_CORRECT. That's what it's there for, and that's when I think the
> warnings should be issued, as I said at the beginning.
>
> But since Paul rejected that, ok, a different variable that lets us turn
> them off (GREPWARNINGS=efgrepok or whatever) would at least provide some
> palliation. I don't understand why you two are opposed to this simple
> remediation.
>
>     As Gary mentioned above, it's easy to disable them.
>
> Obviously it is trivial to edit the scripts or have a different version
> in PATH for my own machine(s).  But those are no substitute for having a
> supported way to use the distributed [ef]grep without warnings.
>
>     I would argue that it is even more important to retain these
>     stray-backslash warnings, because they tend to highlight real bugs.
>
> "tend" being the key word there. But anyway, I see your point, and won't
> argue that one further, since the efgrep warnings are what's causing me
> the agony. -k

Hi Karl,

It would help if you could point to some malfunction.

Consider the alternative.

Should we release a new version of grep that provides a documented way
(say a configure-time option) to disable a warning about a
long-deprecated feature so you don't have to manually tweak the
four-line fgrep and egrep scripts? AFAIK, these new warnings cause no
malfunction.

Wouldn't it be better to fix the roots of the problem rather than
piling another kludge on top to disable the annoying warnings? Think
about the next steps: when more and more distros cease to distribute
the egrep and fgrep crutches, what will people do? Eventually, we'll
all break the habit, at least in scripts. If you want to use it in
personal scripts or on the command line, create your wrapper script or
alias/function.




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 9 Sep 2022 16:42:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 09 12:42:04 2022
Received: from localhost ([127.0.0.1]:35260 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oWh4t-0001bw-PJ
	for submit <at> debbugs.gnu.org; Fri, 09 Sep 2022 12:42:04 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:55904)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1oWh4o-0001bN-PY
 for 57604 <at> debbugs.gnu.org; Fri, 09 Sep 2022 12:42:02 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 8AEDD160063;
 Fri,  9 Sep 2022 09:41:51 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id URBT1j14HtOr; Fri,  9 Sep 2022 09:41:50 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 9D14C160082;
 Fri,  9 Sep 2022 09:41:50 -0700 (PDT)
DKIM-Filter: OpenDKIM Filter v2.9.2 zimbra.cs.ucla.edu 9D14C160082
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cs.ucla.edu;
 s=78364E5A-2AF3-11ED-87FA-8298ECA2D365; t=1662741710;
 bh=kw2cupxKBKZ3fVQk4Jub7OJuxgAPlBM3uQkYRSs8G8k=;
 h=Message-ID:Date:MIME-Version:Subject:To:From:Content-Type:
 Content-Transfer-Encoding;
 b=PsAZOJU9NX+Z4m77O0DHLTBUrJXoMmSCqMQdRtbe7N+ViJB3fxOVoQbVeJuUKZE3U
 E243oXK26rEZa89fTkMoLHIswgXIJiX0mnn7Cr2D9dmBHPa0DsjmdlDDrXjSRCF6mj
 Hvzuhc/jpjc2FfiAB0lnytySgUU0Y9mKjUihKfUg=
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id RTeepKTa77H6; Fri,  9 Sep 2022 09:41:50 -0700 (PDT)
Received: from [192.168.0.205] (ip72-206-2-24.fv.ks.cox.net [72.206.2.24])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 53342160063;
 Fri,  9 Sep 2022 09:41:50 -0700 (PDT)
Message-ID: <856f3501-ad07-8102-3098-50aa606d8932@HIDDEN>
Date: Fri, 9 Sep 2022 11:41:49 -0500
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Content-Language: en-US
To: Guillem Jover <guillem@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
 <Yxsuig0PPYmXPPX0@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
In-Reply-To: <Yxsuig0PPYmXPPX0@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 9/9/22 07:16, Guillem Jover wrote:
> There are now packages that fail to work such as
> apt-file (https://bugs.debian.org/1019329),

 From what I can see, that bug report doesn't say that apt-file fails to 
work, only that apt-file issues a warning and then goes on to work.

> Transitioning away from fgrep/egrep seems like it would be painful as
> that involves lots of upstream projects:

I glanced at those, and didn't see any projects that will stop working, 
only projects that will see annoying warnings. Admittedly I didn't look 
at all the examples, but in the first page of 
<https://codesearch.debian.net/search?q=fgrep&literal=1> (your first 
citation) all the code examples should continue to work.

Could you give examples of programs that actually stop working? That 
would help us consider remedies.





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 9 Sep 2022 15:13:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 09 11:13:21 2022
Received: from localhost ([127.0.0.1]:35014 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oWfh2-0003GX-FJ
	for submit <at> debbugs.gnu.org; Fri, 09 Sep 2022 11:13:20 -0400
Received: from master.debian.org ([82.195.75.110]:53658)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <guillem@HIDDEN>) id 1oWcve-0006Zj-TB
 for 57604 <at> debbugs.gnu.org; Fri, 09 Sep 2022 08:16:19 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=debian.org; 
 s=smtpauto.master;
 h=Content-Type:MIME-Version:Message-ID:Subject:To:From:
 Date:Reply-To:Cc:Content-Transfer-Encoding:Content-ID:Content-Description:
 In-Reply-To:References; bh=RpeOeiNo4d8P2Jg/mSjM7GTnJuApkYv0X/1T26tw+Uo=; b=Xu
 ZBUnpE7o8w/8sv1s3BQzxm97PCbwPcdepnJDX86/4B1GYx+3FHCgiq2u8Ze6U9aLHv34HXiGFRKwo
 uYdjCv++wTgtxRmYR9q7AH12+03ayKKJYhtX0sFFRpWleI3neX6J6pUMXhD1OtKG+FOOval9Lb/QT
 b23W9qYy4zKrSLHX09Qx0QMKP/c53DJjDPk40ppYvKWhn84pGJdVmphT6GAKBLUyhodBfKPqt5Xp+
 BvDN7WWkeXeR8lcdrJRxmP+uyZXnXpcR9ofkXuKI6pzH22702fyz7r23fbXVRwos/G3zxucvbIca5
 K7Q6+VAzv0f5N0eM1E5Vy1x8I4SOJP/g==;
Received: from guillem by master.debian.org with local (Exim 4.94.2)
 (envelope-from <guillem@HIDDEN>) id 1oWcvc-00En5j-SZ
 for 57604 <at> debbugs.gnu.org; Fri, 09 Sep 2022 12:16:12 +0000
Date: Fri, 9 Sep 2022 14:16:10 +0200
From: Guillem Jover <guillem@HIDDEN>
To: 57604 <at> debbugs.gnu.org
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <Yxsuig0PPYmXPPX0@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 57604
X-Mailman-Approved-At: Fri, 09 Sep 2022 11:13:16 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi!

Just to note since grep 3.8 got uploaded into Debian, this has been a
problematic change. There are now packages that fail to work such as
apt-file (https://bugs.debian.org/1019329), and the emission of tons
of warnings all over the place, in many cases hard to know where these
are coming from, if the invoking command is nested deep.

Transitioning away from fgrep/egrep seems like it would be painful as
that involves lots of upstream projects:

  https://codesearch.debian.net/search?q=fgrep&literal=1
  https://codesearch.debian.net/search?q=egrep&literal=1

(And https://codesearch.debian.net/search?q=rgrep&literal=1)

In Debian the grep package has been blocked from migrating from
unstable to testing, and this change might get reverted:

  https://bugs.debian.org/1019335

There's a check by shellcheck, but unfortunately not everyone runs that
over shell code.

(Personally I'm happy to adapt code I maintain for this kind of thing,
but from reading older discussions upstream I get the feeling the
theoretical reach of these tools usage was perhaps not calibrated against
actual usage?)

Thanks,
Guillem




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 8 Sep 2022 23:01:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 08 19:01:09 2022
Received: from localhost ([127.0.0.1]:60460 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oWQWD-00011U-GN
	for submit <at> debbugs.gnu.org; Thu, 08 Sep 2022 19:01:09 -0400
Received: from freefriends.org ([96.88.95.60]:39232)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oWQWC-00011L-6J
 for 57604 <at> debbugs.gnu.org; Thu, 08 Sep 2022 19:01:08 -0400
X-Envelope-From: karl@HIDDEN
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 288N11RP020588
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT); 
 Thu, 8 Sep 2022 17:01:02 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 288N11Ta020587;
 Thu, 8 Sep 2022 17:01:01 -0600
Date: Thu, 8 Sep 2022 17:01:01 -0600
Message-Id: <202209082301.288N11Ta020587@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: jim@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Jim,

    Some must care about portability, 
    
Certainly agreed. Even I do, sometimes :). But that does not mean
everyone needs to, in every situation.  As I said, I fail to understand
the benefit of making the warning unconditional.

So far as I can see, it's also against GNU principles, as I wrote,
though evidently you don't agree.

    and these warnings help them do a better job.

When people want extreme POSIX compliance, they should set
POSIXLY_CORRECT. That's what it's there for, and that's when I think the
warnings should be issued, as I said at the beginning.

But since Paul rejected that, ok, a different variable that lets us turn
them off (GREPWARNINGS=efgrepok or whatever) would at least provide some
palliation. I don't understand why you two are opposed to this simple
remediation.

    As Gary mentioned above, it's easy to disable them.

Obviously it is trivial to edit the scripts or have a different version
in PATH for my own machine(s).  But those are no substitute for having a
supported way to use the distributed [ef]grep without warnings.

    I would argue that it is even more important to retain these
    stray-backslash warnings, because they tend to highlight real bugs.

"tend" being the key word there. But anyway, I see your point, and won't
argue that one further, since the efgrep warnings are what's causing me
the agony. -k




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 8 Sep 2022 09:22:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 08 05:22:18 2022
Received: from localhost ([127.0.0.1]:57274 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oWDjm-0007oi-Dn
	for submit <at> debbugs.gnu.org; Thu, 08 Sep 2022 05:22:18 -0400
Received: from mail-lf1-f44.google.com ([209.85.167.44]:43951)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <meyering@HIDDEN>) id 1oWDjV-0007ny-UT
 for 57604 <at> debbugs.gnu.org; Thu, 08 Sep 2022 05:22:17 -0400
Received: by mail-lf1-f44.google.com with SMTP id x14so11333955lfu.10
 for <57604 <at> debbugs.gnu.org>; Thu, 08 Sep 2022 02:22:01 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date;
 bh=9F8zAu/Z4+GsZD/Ook7T8o7kWr99Ny6jdLNIKYbCWlQ=;
 b=r2EOBQ6fBjWGpP1r6HwLJXRyhjuE/vCupiEERg3KHgpVvZlJ385Bc8ctzu1Eg3BZ9H
 s4qMoDOmARkmU41lAgHR+8tnVVcdeqKNecMuIlogYhQfw/Z7YqeEpJz2jjqzADgob3SM
 I0/8UofbdgR31Con7J+RY4uCxRS2hXAh6POnEZY1uyxdtUHwQDxu2kAEaAqlSzGh6qRH
 ATIdSWP19HS4PtEg2qYbfDgEiW8un4YRxQQJEXsR9EhdPlFmF/DxqxNl8EhhzyB9BrEE
 XDrObHoP/iuRzb+g2IvkjrrkuY631ykfvYdSFhqe5mX/9vndY2Pb4+J7ciNiSFUEsVpC
 OmQQ==
X-Gm-Message-State: ACgBeo3LfO2TP6416TeNL/JJbTYdBmqeC6qqdDPZZn6yThNfy59XtZeS
 sqUFJkybdRW2QY3yBP+6ntfpzoxjSSI/YcrFF1g=
X-Google-Smtp-Source: AA6agR7suFEP8ZaRlKQsXY63b5kmnEdIJChMIxgzn0YJ+Ykpq5bkkWISitafJjUi9xeQKdemvDWLV/esq74SdWapuxM=
X-Received: by 2002:ac2:4ece:0:b0:497:a770:1bb4 with SMTP id
 p14-20020ac24ece000000b00497a7701bb4mr2057844lfr.47.1662628915611; Thu, 08
 Sep 2022 02:21:55 -0700 (PDT)
MIME-Version: 1.0
References: <202209052207.285M7Z3i005737@HIDDEN>
 <87bkrrk3yb.fsf@HIDDEN>
 <202209072235.287MZH2t030514@HIDDEN>
In-Reply-To: <202209072235.287MZH2t030514@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Thu, 8 Sep 2022 02:21:42 -0700
Message-ID: <CA+8g5KHDC2qqj9DiH6bysnv-OpKw1TF4rjSru0ZnkHJUU78B0g@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
To: Karl Berry <karl@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi Karl,

Sorry to cause you grief, but...

On Wed, Sep 7, 2022 at 7:49 PM Karl Berry <karl@HIDDEN> wrote:
>
>     [ef]grep
>
> I guess my basic issue is that I don't understand the benefit of the new
> warning.  It causes a lot of trouble.  What is the countervailing
> positive benefit?

Some must care about portability, and these warnings help them do a better job.
As Gary mentioned above, it's easy to disable them.

>     $ grep '\Q' /dev/null
>     grep: warning: stray \ before Q

> It would be nice to be able to turn those off too. (It hit me today.)

I would argue that it is even more important to retain these
stray-backslash warnings, because they tend to highlight real bugs.
Consider these uses of \d:

  $ echo d | grep-3.7 '\d'
  d
  $ echo d | grep-3.8 '\d'
  grep: warning: stray \ before d

Anyone used to PCRE regexps (who isn't, these days) knows that its
"\d" is intended to match a digit, not the letter "d". With grep-3.7,
you'd get misbehavior and no warning about your error. With grep-3.8,
you'll get the diagnostic and maybe switch to using "grep -P", where
"\d" works as expected -- switching from \d to [0-9] hurts readability
and feels like dumbing-down, especially when there are two or more \d
uses. Using PCRE's \Q...\E groups *without -P* is another issue that
is now diagnosed.

For example, the following upstream projects have misuses of grep that
are exposed by running this:

  git grep 'grep .*\\[dQE]' | grep -ve '-[[:alnum:]]*P'

- linux
scripts/checkpatch.pl:          `grep -Eq
"\\"\\^\Q$vendor\E,\\.\\*\\":" $vp_file`;

- gcc
libgo/go/cmd/go/testdata/script/mod_get_lazy_indirect.txt:grep
'rsc.io/quote v\d+\.\d+\.\d+ // indirect$' go.mod
libgo/go/cmd/go/testdata/script/mod_get_lazy_indirect.txt:! grep
'rsc.io/quote v\d+\.\d+\.\d+$' go.mod
libgo/go/cmd/go/testdata/script/mod_get_lazy_indirect.txt:grep
'rsc.io/quote v\d+\.\d+\.\d+$' go.mod
libgo/go/cmd/go/testdata/script/mod_get_lazy_indirect.txt:! grep
'rsc.io/quote v\d+\.\d+\.\d+ // indirect$' go.mod




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 22:35:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 18:35:20 2022
Received: from localhost ([127.0.0.1]:56435 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oW3dg-0001S0-MD
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:20 -0400
Received: from freefriends.org ([96.88.95.60]:56104)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oW3df-0001Rk-CF
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:19 -0400
X-Envelope-From: karl@HIDDEN
X-Envelope-To: <57604 <at> debbugs.gnu.org>
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 287MZIhW030524
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT)
 for <57604 <at> debbugs.gnu.org>; Wed, 7 Sep 2022 16:35:18 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 287MZIMA030523;
 Wed, 7 Sep 2022 16:35:18 -0600
Date: Wed, 7 Sep 2022 16:35:18 -0600
Message-Id: <202209072235.287MZIMA030523@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: 57604 <at> debbugs.gnu.org
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <87fsh3k49f.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

    simpler solution to undeprecate the tools in documentation and have
    them be official GNU-enhancements as they de-facto has been for the
    past 20+ years

+20

    My pet issue was the inconsistency between documentation and reality, 

Agreed.

    I think the simplest way to fix that is to drop the tools

Not that anyone cares, but IMHO the simplest way is to delete the new
warning lines. End of problem.

    issue warnings: on some current systems (I think it was Alpine)
    is no egrep and fgrep any more

To my understanding, GNU should not cater to the lowest common
denominator, or be unfriendly to users. To quote from the coding
standards:

  Standard C and POSIX prohibit many kinds of extensions.  Feel
  free to make the extensions anyway ...
  ...
  But we do not follow either of these specifications [ANSI C and POSIX]
  rigidly, and there are specific points on which we decided not to
  follow them, so as to make the GNU system better for users.
  ...
  In particular, don't reject a new feature, or remove an old one,
                                             ^^^^^^^^^^^^^^^^^^^^
  merely because a standard says it is ``forbidden'' or ``deprecated''.

--karl




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 22:35:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 18:35:20 2022
Received: from localhost ([127.0.0.1]:56433 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oW3dg-0001Rt-CC
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:20 -0400
Received: from freefriends.org ([96.88.95.60]:56100)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oW3de-0001RY-E2
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:18 -0400
X-Envelope-From: karl@HIDDEN
X-Envelope-To: <57604 <at> debbugs.gnu.org>
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 287MZHC3030515
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT)
 for <57604 <at> debbugs.gnu.org>; Wed, 7 Sep 2022 16:35:17 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 287MZH2t030514;
 Wed, 7 Sep 2022 16:35:17 -0600
Date: Wed, 7 Sep 2022 16:35:17 -0600
Message-Id: <202209072235.287MZH2t030514@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: 57604 <at> debbugs.gnu.org
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <87bkrrk3yb.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

    [ef]grep

I guess my basic issue is that I don't understand the benefit of the new
warning.  It causes a lot of trouble.  What is the countervailing
positive benefit?

    $ grep '\Q' /dev/null
    grep: warning: stray \ before Q

It would be nice to be able to turn those off too. (It hit me today.)

Those warnings are even worse than [ef]grep in a way, since they are not
changeable just by editing the scripts, but built-in behavior.

    We've been moving away from environment variables like GREP_OPTIONS, 
    though, for security reasons. 

Personally, I don't see a security issue with the putative GREPWARNINGS?
Unlike GREP_OPTIONS, whose removal is understandable (though it sure was
convenient, alas). --karl




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 22:35:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 18:35:20 2022
Received: from localhost ([127.0.0.1]:56431 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oW3dg-0001Rq-2p
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:20 -0400
Received: from freefriends.org ([96.88.95.60]:56096)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oW3dd-0001RW-Qh
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 18:35:18 -0400
X-Envelope-From: karl@HIDDEN
X-Envelope-To: <57604 <at> debbugs.gnu.org>
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 287MZG0W030497
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT)
 for <57604 <at> debbugs.gnu.org>; Wed, 7 Sep 2022 16:35:16 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 287MZELg030495;
 Wed, 7 Sep 2022 16:35:14 -0600
Date: Wed, 7 Sep 2022 16:35:14 -0600
Message-Id: <202209072235.287MZELg030495@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: 57604 <at> debbugs.gnu.org
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <87bkrrk3yb.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

    sj> Personally, I'd rather have tools exit with an error code on
    invalid uses rather than issuing warning messages.

For me (and according to historical practice), an unnecessary \ is not
invalid. So, not surprisingly, I, on the other hand, would rather have
grep provide a way to turn off the warning (or go back to not warning by
default, but I guess that argument has been rejected).  --karl




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 19:26:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 15:26:19 2022
Received: from localhost ([127.0.0.1]:56312 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oW0gl-0000t9-A8
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 15:26:19 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:60332)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1oW0gj-0000sj-2G
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 15:26:18 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 0F1DD160063;
 Wed,  7 Sep 2022 12:26:10 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id K5djv3sKgCgy; Wed,  7 Sep 2022 12:26:09 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 523E6160067;
 Wed,  7 Sep 2022 12:26:09 -0700 (PDT)
DKIM-Filter: OpenDKIM Filter v2.9.2 zimbra.cs.ucla.edu 523E6160067
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cs.ucla.edu;
 s=78364E5A-2AF3-11ED-87FA-8298ECA2D365; t=1662578769;
 bh=LMGhE09qqlLd6IRMJTYpgEZKMeVlreSjjqdS8zzNa0k=;
 h=Message-ID:Date:MIME-Version:Subject:To:From:Content-Type:
 Content-Transfer-Encoding;
 b=OwZXcbmZdobpW8xVgUcSp5oGpcF9hEaxJkskkDsSrmGDATvVJLnhbS+tilwtWPmq0
 sptjusf2JaIIKYyGlA+FiW8+WsxoDix11n0QO/2lDLSzHvZ0vUMNYE+nCSReYehEVP
 /4Mnast9KeUcGuYYmN8H4murGqy7PxBSAC8kn2tY=
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id vTKynaY2tjkn; Wed,  7 Sep 2022 12:26:09 -0700 (PDT)
Received: from [192.168.0.205] (ip72-206-2-24.fv.ks.cox.net [72.206.2.24])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id E7BD2160063;
 Wed,  7 Sep 2022 12:26:08 -0700 (PDT)
Message-ID: <c759bad6-d239-5065-d44b-c0cf3ddccbb5@HIDDEN>
Date: Wed, 7 Sep 2022 14:26:07 -0500
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Content-Language: en-US
To: Simon Josefsson <simon@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
 <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN>
 <87bkrrk3yb.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
In-Reply-To: <87bkrrk3yb.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org, karl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 9/7/22 03:02, Simon Josefsson via Bug reports for GNU grep wrote:
>> $ grep '\Q' /dev/null
>> grep: warning: stray \ before Q
>> $ grep '[:alpha:]' /dev/null
>> grep: character class syntax is [[:space:]], not [:space:]
> Is the use of diagnostic warnings like this supported by POSIX?

Yes, POSIX says that \Q produces undefined results, and that [:alpha:] 
can be treated as either [[:alpha:]], [:alph], or an error (the last is 
the GNU behavior).

> I'd rather have tools exit with an error code on invalid
> uses rather than issuing warning messages.

GNU grep does that for [:alpha:]. At some point it should do the same 
for \Q, as \Q's behavior is squirrelly anyway. I thought it might be too 
disruptive to do it for \Q right away so in 3.8 \Q merely gets warned about.





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Sep 2022 12:50:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 08:50:24 2022
Received: from localhost ([127.0.0.1]:53918 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVuVb-0002cE-Si
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 08:50:24 -0400
Received: from lists.gnu.org ([209.51.188.17]:54912)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <garyjohn@HIDDEN>) id 1oVuVa-0002c6-5H
 for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 08:50:22 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:57736)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <garyjohn@HIDDEN>)
 id 1oVuVZ-0008DM-Tk
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 08:50:21 -0400
Received: from mail.spocom.com ([206.63.224.240]:61416)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <garyjohn@HIDDEN>) id 1oVuVW-0007Y6-1W
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 08:50:21 -0400
DomainKey-Signature: a=rsa-sha1; c=nofws; q=dns; d=spocom.com; s=mail;
 h=received:date:from:to:subject:message-id:mail-followup-to
 :references:mime-version:content-type:content-disposition
 :in-reply-to:x-operating-system:user-agent;
 b=rJsQRvSVkMpIS0YOd0MVEUMPlikF1tnYf8ZiPMNmaGwqvhZ3NaBIy4AZx7cH0MAhU
 ulWLMZuKH4zamo6CfPONw==
Received: from localhost (174-31-102-185.spkn.qwest.net [174.31.102.185]) by
 mail.spocom.com with SMTP; Wed, 7 Sep 2022 05:34:54 -0700
Date: Wed, 7 Sep 2022 05:36:10 -0700
From: Gary Johnson <garyjohn@HIDDEN>
To: bug-grep@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <20220907123610.GI6741@phoenix>
Mail-Followup-To: bug-grep@HIDDEN
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
 <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN>
 <87bkrrk3yb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87bkrrk3yb.fsf@HIDDEN>
X-Operating-System: Linux 2.6.32-74-generic GNU/Linux
User-Agent: Mutt/1.5.20 (2009-06-14)
Received-SPF: pass client-ip=206.63.224.240; envelope-from=garyjohn@HIDDEN;
 helo=mail.spocom.com
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On 2022-09-07, Simon Josefsson via Bug reports for GNU grep wrote:

> Personally, I'd rather have tools exit with an error code on invalid
> uses rather than issuing warning messages.

The warning messages are merely annoying.  Returning a non-zero exit
status would break scripts, and in many cases, silently.

Regards,
Gary





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Sep 2022 12:47:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 08:47:07 2022
Received: from localhost ([127.0.0.1]:53878 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVuSR-0002Us-3u
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 08:47:07 -0400
Received: from lists.gnu.org ([209.51.188.17]:46496)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <garyjohn@HIDDEN>) id 1oVuSP-0002Uk-2r
 for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 08:47:05 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:50816)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <garyjohn@HIDDEN>)
 id 1oVuSL-0004qs-IH
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 08:47:04 -0400
Received: from mail.spocom.com ([206.63.224.240]:61301)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <garyjohn@HIDDEN>) id 1oVuSJ-0006yt-Au
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 08:47:01 -0400
DomainKey-Signature: a=rsa-sha1; c=nofws; q=dns; d=spocom.com; s=mail;
 h=received:date:from:to:subject:message-id:mail-followup-to
 :references:mime-version:content-type:content-disposition
 :in-reply-to:x-operating-system:user-agent;
 b=2uR4/5npzbmQhl7QOzuXhiW1HwcC0Xd0B4D39hKSPKHfO6Vmf4l9eKJePPeCn+Arb
 FaaXmuYBplm2ziMZMVRsw==
Received: from localhost (174-31-102-185.spkn.qwest.net [174.31.102.185]) by
 mail.spocom.com with SMTP; Wed, 7 Sep 2022 05:46:37 -0700
Date: Wed, 7 Sep 2022 05:47:53 -0700
From: Gary Johnson <garyjohn@HIDDEN>
To: bug-grep@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Message-ID: <20220907124753.GJ6741@phoenix>
Mail-Followup-To: bug-grep@HIDDEN
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
 <87fsh3k49f.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87fsh3k49f.fsf@HIDDEN>
X-Operating-System: Linux 2.6.32-74-generic GNU/Linux
User-Agent: Mutt/1.5.20 (2009-06-14)
Received-SPF: pass client-ip=206.63.224.240; envelope-from=garyjohn@HIDDEN;
 helo=mail.spocom.com
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On 2022-09-07, Simon Josefsson via Bug reports for GNU grep wrote:

> On the other hand, it seems your main problem here is the warning: and I
> agree that is annoying and should be fixed.  There doesn't seem to be
> any way to disable it now?  It would be nice to fix that.
> 
> I think the simplest way to fix that is to drop the tools rather than to
> issue warnings: on some current systems (I think it was Alpine), there
> is no egrep and fgrep any more, and dealing with non-existing tools
> (discover the error, then use egrep -E or add a personal alias for
> interactive use) is easier than dealing with annoying warnings that
> cannot be disabled.

The warnings I see don't come from anything I've written; they've
been coming from third-party tools.  I'd rather not modify those.

Disabling the warnings is fairly simple.  Do one of the following.

1.  Edit the egrep and fgrep scripts to remove the warnings.
2.  Copy the egrep and fgrep scripts to ~/bin (someplace in PATH
    earlier than where the grep installation put them) and edit
    those copies to remove the warnings.

Regards,
Gary





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 08:02:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 04:02:10 2022
Received: from localhost ([127.0.0.1]:53300 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVq0g-0001Di-JD
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 04:02:10 -0400
Received: from uggla.sjd.se ([178.174.241.107]:57396)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <simon@HIDDEN>) id 1oVq0e-0001DY-0Q
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 04:02:08 -0400
DKIM-Signature: v=1; a=ed25519-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=ed2110; h=Content-Type:MIME-Version:Message-ID:In-Reply-To
 :Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding
 :Content-ID:Content-Description;
 bh=BxVjJQUQm7w5Ocik9FVyX+K9+G5BjJTI6WVk9WhdZfI=; t=1662537728; x=1663747328; 
 b=pE5gqhRbVT54R1420xje/Ofb8OYk5VbdAVHFjm16PNDIXv20NH7XRbgKNgQfW05qN2/j1woBKNu
 7dgxJ8rb3Bg==;
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=rsa2110; h=Content-Type:MIME-Version:Message-ID:
 In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description;
 bh=BxVjJQUQm7w5Ocik9FVyX+K9+G5BjJTI6WVk9WhdZfI=; t=1662537728; x=1663747328; 
 b=NYiE623hn0BWkZOnUhxPZ1Ae1HQnCKLGer23YdT8ExeaW0zB/D1Xg0/3skv36qkZ65rKhQ0Xso0
 HNr4cDIIymu2w2YNWXU++JnaPYrasNhL+jgDQZmc6tHu9qVuKxrgldAUMYit6ZdJ+6VE671XXmDX1
 J9+qdLtRa5Wi28P7HHXS9YdQ+CG3jIteb8e1Bkh3U3mV2jpqknqBsYFwjxR0y3YNIh2HylGRccYu9
 f/2hEbIBJYHWtQvpXaITBe2KgjaioFERNo8ZEbNGDGZvyZ8725o4tGk1VSVhhO+rfYgz9I1lsw3kq
 8fRCr1TF2RR2/3Lt4cDP6j/kAzMmrg1ojJdxaL7erXqpcsYcuUxIHWOUU5lakOeUNXyA8NaYZ6mNw
 kU3xRjzaA62rarH43IWlWDsEfmsHG4S4m/ZGf3EVTL71lVWf9dTZtiCkF+3091pnsTmepuNP2;
Received: from [2001:9b1:41ac:ff00:8ab3:8890:dba1:fd0e] (port=36790 helo=latte)
 by uggla.sjd.se with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94.2)
 (envelope-from <simon@HIDDEN>)
 id 1oVq0b-00EzCk-Bi; Wed, 07 Sep 2022 10:02:05 +0200
From: Simon Josefsson <simon@HIDDEN>
To: Paul Eggert via Bug reports for GNU grep <bug-grep@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
 <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN>
OpenPGP: id=B1D2BD1375BECB784CF4F8C4D73CF638C53C06BE;
 url=https://josefsson.org/key-20190320.txt
X-Hashcash: 1:22:220907:57604 <at> debbugs.gnu.org::vnmLyRqGGIrUQI15:bVu
X-Hashcash: 1:22:220907:eggert@HIDDEN::25J6jz5n/sE5o4m0:eEm
X-Hashcash: 1:22:220907:bug-grep@HIDDEN::RaO7myGH06KGVT+f:9kEZ
X-Hashcash: 1:22:220907:karl@HIDDEN::D/zpQDfRYu6XiTMz:HzwI
Date: Wed, 07 Sep 2022 10:02:04 +0200
In-Reply-To: <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN> (Paul Eggert
 via Bug reports for's message of "Tue, 6 Sep 2022 15:52:13 -0500")
Message-ID: <87bkrrk3yb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org, Karl Berry <karl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Paul Eggert via Bug reports for GNU grep <bug-grep@HIDDEN> writes:

> $ grep '\Q' /dev/null
> grep: warning: stray \ before Q
> $ grep '[:alpha:]' /dev/null
> grep: character class syntax is [[:space:]], not [:space:]

Is the use of diagnostic warnings like this supported by POSIX?
Personally, I'd rather have tools exit with an error code on invalid
uses rather than issuing warning messages.

/Simon

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIoEARYIADIWIQSjzJyHC50xCrrUzy9RcisI/kdFogUCYxhP/RQcc2ltb25Aam9z
ZWZzc29uLm9yZwAKCRBRcisI/kdFohoRAQCGcqPtIYwHf+capphvwuB5DryiwQzB
kajDXuPE8WghzQD/ctU8Eo96hsJeDiBd+k+J7/nVwxykPINwkEDdtcpK2QU=
=hq2c
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Sep 2022 08:02:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 04:02:24 2022
Received: from localhost ([127.0.0.1]:53304 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVq0t-0001EA-UA
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 04:02:24 -0400
Received: from lists.gnu.org ([209.51.188.17]:50904)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <simon@HIDDEN>) id 1oVq0r-0001E1-LF
 for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 04:02:22 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:37210)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <simon@HIDDEN>)
 id 1oVq0r-0003C6-FV
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 04:02:21 -0400
Received: from uggla.sjd.se ([2001:9b1:8633::107]:46080)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <simon@HIDDEN>)
 id 1oVq0k-0003zj-8N
 for bug-grep@HIDDEN; Wed, 07 Sep 2022 04:02:21 -0400
DKIM-Signature: v=1; a=ed25519-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=ed2110; h=Content-Type:MIME-Version:Message-ID:In-Reply-To
 :Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding
 :Content-ID:Content-Description;
 bh=BxVjJQUQm7w5Ocik9FVyX+K9+G5BjJTI6WVk9WhdZfI=; t=1662537730; x=1663747330; 
 b=fNrdGrI5dUI5uYtiwGQxO8pp80o9hMi4pFBhrYyocCUAZsoQVadTuddXvopQoHpDGP8fQR507fx
 jeEMDYuH9Ag==;
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=rsa2110; h=Content-Type:MIME-Version:Message-ID:
 In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description;
 bh=BxVjJQUQm7w5Ocik9FVyX+K9+G5BjJTI6WVk9WhdZfI=; t=1662537730; x=1663747330; 
 b=fEo+JCNr6M1xnUXg4AbG1YQliT1CC9VSGCRfbx6cnyyOHYw9Oy9KVhbQ0Qrz5spZKI1SfK841Zv
 lRDwZ41PHRswlgkguNosw2GHKEGG+JUjNHaTjqjQyfcMappt9/r1S4pYeTcRh6AErYgW0lqQYWC5u
 5rNuMJLS+ogpxuJrEcEIZEIAULWZlIDjaCUMlNDrvwPTxnCsyjjDnuMfQDvMm21bG6pXumqPTEa6C
 wAKKisEBG6uXHObDICiJG1ZTkFvqhq6wvRqf61EA342aestx9krd4jx9wVbfcS8Qhzit02fZNLatd
 4XZdtI5DeysCTg31+iv+/gx5KNtFafqRfc05F6xjSRhH+Q4xWjWnhl6HJyWuf1Ou2YYrVeNuF+ucE
 hlb9v4pHiTUrv2F7DIp5zaGveJ499z7rR+he4TvGTpYcnXnYW1iggAK4B3UaUxFMDOhHqDYPC;
Received: from [2001:9b1:41ac:ff00:8ab3:8890:dba1:fd0e] (port=36790 helo=latte)
 by uggla.sjd.se with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94.2)
 (envelope-from <simon@HIDDEN>)
 id 1oVq0b-00EzCk-Bi; Wed, 07 Sep 2022 10:02:05 +0200
From: Simon Josefsson <simon@HIDDEN>
To: Paul Eggert via Bug reports for GNU grep <bug-grep@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
 <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN>
OpenPGP: id=B1D2BD1375BECB784CF4F8C4D73CF638C53C06BE;
 url=https://josefsson.org/key-20190320.txt
X-Hashcash: 1:22:220907:57604 <at> debbugs.gnu.org::vnmLyRqGGIrUQI15:bVu
X-Hashcash: 1:22:220907:eggert@HIDDEN::25J6jz5n/sE5o4m0:eEm
X-Hashcash: 1:22:220907:bug-grep@HIDDEN::RaO7myGH06KGVT+f:9kEZ
X-Hashcash: 1:22:220907:karl@HIDDEN::D/zpQDfRYu6XiTMz:HzwI
Date: Wed, 07 Sep 2022 10:02:04 +0200
In-Reply-To: <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN> (Paul Eggert
 via Bug reports for's message of "Tue, 6 Sep 2022 15:52:13 -0500")
Message-ID: <87bkrrk3yb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
Received-SPF: pass client-ip=2001:9b1:8633::107;
 envelope-from=simon@HIDDEN; helo=uggla.sjd.se
X-Spam_score_int: -43
X-Spam_score: -4.4
X-Spam_bar: ----
X-Spam_report: (-4.4 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_MED=-2.3, SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: 57604 <at> debbugs.gnu.org, Karl Berry <karl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain

Paul Eggert via Bug reports for GNU grep <bug-grep@HIDDEN> writes:

> $ grep '\Q' /dev/null
> grep: warning: stray \ before Q
> $ grep '[:alpha:]' /dev/null
> grep: character class syntax is [[:space:]], not [:space:]

Is the use of diagnostic warnings like this supported by POSIX?
Personally, I'd rather have tools exit with an error code on invalid
uses rather than issuing warning messages.

/Simon

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIoEARYIADIWIQSjzJyHC50xCrrUzy9RcisI/kdFogUCYxhP/RQcc2ltb25Aam9z
ZWZzc29uLm9yZwAKCRBRcisI/kdFohoRAQCGcqPtIYwHf+capphvwuB5DryiwQzB
kajDXuPE8WghzQD/ctU8Eo96hsJeDiBd+k+J7/nVwxykPINwkEDdtcpK2QU=
=hq2c
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 07:55:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 03:55:33 2022
Received: from localhost ([127.0.0.1]:53295 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVpuG-00011o-K5
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 03:55:32 -0400
Received: from uggla.sjd.se ([178.174.241.107]:43478)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <simon@HIDDEN>) id 1oVpuC-00011d-Tx
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 03:55:31 -0400
DKIM-Signature: v=1; a=ed25519-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=ed2110; h=Content-Type:MIME-Version:Message-ID:In-Reply-To
 :Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding
 :Content-ID:Content-Description;
 bh=mpHEjxP09+EZxwcK3UHxRgUIFobuYwj5+lzVz93A/NE=; t=1662537328; x=1663746928; 
 b=U4s1oiUPrgdY/4DrB7yhJ6hHMXLIJ4ZTU0LIQ3swENv7FcVYAUgWgf+opuImOsAFEPkqFPSJgPr
 YT3TvolnbBA==;
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=josefsson.org; s=rsa2110; h=Content-Type:MIME-Version:Message-ID:
 In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:
 Content-Transfer-Encoding:Content-ID:Content-Description;
 bh=mpHEjxP09+EZxwcK3UHxRgUIFobuYwj5+lzVz93A/NE=; t=1662537328; x=1663746928; 
 b=rZNWryS+KjZh3E0otstLS3APlg4UeyfETs7zgo4htXP/LoAjYiznmUx1EuFcR5pp1WtRJhmNCEp
 e0SASsPwPLVR46r5jKCqkexz75fFo0tKD9em+2r+AJZD9HStPHj90WSMmXywC3TTM/au9Lrhu8f6A
 kGvwJS4UcBFKocWC9MAmYy94yCDChDsknBjUXOJVmPDhI5JVPa3m1yrbLINvQ/Vkn6nIc7ZcwYKlR
 BpCBu52OzLQ0CV+l23Eb9g61SUWUPX8B/QmfH9F2OkoT6eUvFhdM2sOcRCl/Ja8QQp5b+oQo9gDZ+
 rfWOF7dAElzSOLOrL6faFxh8Qv1GKGJF+DEURrpNf6iKR+/idYeT1KLfydyxg534MXKfdCQcd9BSe
 GuukZfl6L6TlcKkuHP0tkjAcO2195S/f2idl9BH7zTg7zmGj6NzyDuy75uACsdy5zhgKbZFfJ;
Received: from [2001:9b1:41ac:ff00:8ab3:8890:dba1:fd0e] (port=33138 helo=latte)
 by uggla.sjd.se with esmtpsa (TLS1.3) tls
 TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 (Exim 4.94.2)
 (envelope-from <simon@HIDDEN>)
 id 1oVpu9-00Eyaz-Ee; Wed, 07 Sep 2022 09:55:25 +0200
From: Simon Josefsson <simon@HIDDEN>
To: Karl Berry <karl@HIDDEN>
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
OpenPGP: id=B1D2BD1375BECB784CF4F8C4D73CF638C53C06BE;
 url=https://josefsson.org/key-20190320.txt
X-Hashcash: 1:22:220907:karl@HIDDEN::M990AsOd/lK6DxUd:04bU
X-Hashcash: 1:22:220907:57604 <at> debbugs.gnu.org::XGchA1DH+B4q4kyZ:1QhE
X-Hashcash: 1:22:220907:eggert@HIDDEN::IdKsYJJVca4/PJCB:DcAb
Date: Wed, 07 Sep 2022 09:55:24 +0200
In-Reply-To: <202209062033.286KX06S017507@HIDDEN> (Karl Berry's
 message of "Tue, 6 Sep 2022 14:33:00 -0600")
Message-ID: <87fsh3k49f.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57604
Cc: eggert@HIDDEN, 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Karl Berry <karl@HIDDEN> writes:

> But, whatever. Since it bothers you to use POSIXLY_CORRECT, let's invent
> some other envvar that turns off the warning, like
> "PLEASE_LET_ME_USE_EFGREP_I_DONT_CARE_ABOUT_POSIX", and Arnold and I
> will set it and life can go on.
>
>     https://bugs.gnu.org/49996
>
> I'm unconvinced. What Simon's bug report says is "hey, why not deprecate
> [ef]grep because it's time". Well, IMHO it's not time, and will never be
> time, and "deprecation" merely means "cause trouble for users for no
> real reason". My "pet issue" is the exact opposite of Simon's ...
>
> Without some way to turn off those warnings, GNU [ef]grep become
> unusable without editing to remove the comment. It is completely
> infeasible, not to mention a tremendous waste of time, to edit
> everywhere on my systems that use them, after 40 years of historical
> usage.
>
> I'm not saying scripts intended to be portable should not be changed (as
> we know, they have had to be, because POSIX forced it). But all the
> scripts in the world which are *not* needed to be portable don't need to
> be changed. They just need to keep working and not be randomly broken by
> outside forces.
>
> [ef]grep are fundamental names for the utility. Please reconsider. -k

I can understand your frustration, and maybe it would have been a
simpler solution to undeprecate the tools in documentation and have them
be official GNU-enhancements as they de-facto has been for the past 20+
years.  My pet issue was the inconsistency between documentation and
reality, and I don't care strongly how to resolve it.

On the other hand, it seems your main problem here is the warning: and I
agree that is annoying and should be fixed.  There doesn't seem to be
any way to disable it now?  It would be nice to fix that.

I think the simplest way to fix that is to drop the tools rather than to
issue warnings: on some current systems (I think it was Alpine), there
is no egrep and fgrep any more, and dealing with non-existing tools
(discover the error, then use egrep -E or add a personal alias for
interactive use) is easier than dealing with annoying warnings that
cannot be disabled.

/Simon

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIoEARYIADIWIQSjzJyHC50xCrrUzy9RcisI/kdFogUCYxhObRQcc2ltb25Aam9z
ZWZzc29uLm9yZwAKCRBRcisI/kdFomgOAQCHOSDP4x46zkRn2DMl60q6oZ2+XL7g
7WCL5sOEBjIRQQEA9CXVgTrOwt1gUC2NaHDOpyo48EIbLLZtaXddkRjLWQA=
=lynQ
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 7 Sep 2022 07:47:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 07 03:47:45 2022
Received: from localhost ([127.0.0.1]:53276 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVpmj-0000np-9A
	for submit <at> debbugs.gnu.org; Wed, 07 Sep 2022 03:47:45 -0400
Received: from freefriends.org ([96.88.95.60]:41332)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arnold@HIDDEN>) id 1oVpmg-0000nQ-Hm
 for 57604 <at> debbugs.gnu.org; Wed, 07 Sep 2022 03:47:43 -0400
X-Envelope-From: arnold@HIDDEN
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 2877ldbA028658
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT); 
 Wed, 7 Sep 2022 01:47:40 -0600
Received: (from arnold@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 2877ldac028657;
 Wed, 7 Sep 2022 01:47:39 -0600
From: arnold@HIDDEN
Message-Id: <202209070747.2877ldac028657@HIDDEN>
X-Authentication-Warning: frenzy.freefriends.org: arnold set sender to
 arnold@HIDDEN using -f
Date: Wed, 07 Sep 2022 01:47:39 -0600
To: karl@HIDDEN, eggert@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
In-Reply-To: <202209062033.286KX06S017507@HIDDEN>
User-Agent: Heirloom mailx 12.5 7/5/10
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

I totally agree here with Karl, obsoleting fgrep and egrep is the
wrong way to go.  It's built into too many scripts world-wide, as
well as burned into the "finger ROMs" of too many users. Not to mention
all the books / training materials that talk about them that people
may have.

Thanks,

Arnold

Karl Berry <karl@HIDDEN> wrote:

>     Actually, egrep and fgrep were not entirely portable 
>
> They were portable to every system I ever used (admittedly not the
> entire world), before POSIX got involved.
>
>     These days, my impression is that it's more portable to use grep -E
>     than to use egrep.
>
> I agree. And IMHO that is a bug POSIX gratuitously introduced.
>
>     That wouldn't be right, as POSIXLY_CORRECT governs misfeatures required 
>     by POSIX, which isn't the case here: 
>
> IMHO it is the case. The misfeature being fixed is POSIX unblessing
> [ef]grep.
>
> But, whatever. Since it bothers you to use POSIXLY_CORRECT, let's invent
> some other envvar that turns off the warning, like
> "PLEASE_LET_ME_USE_EFGREP_I_DONT_CARE_ABOUT_POSIX", and Arnold and I
> will set it and life can go on.
>
>     https://bugs.gnu.org/49996
>
> I'm unconvinced. What Simon's bug report says is "hey, why not deprecate
> [ef]grep because it's time". Well, IMHO it's not time, and will never be
> time, and "deprecation" merely means "cause trouble for users for no
> real reason". My "pet issue" is the exact opposite of Simon's ...
>
> Without some way to turn off those warnings, GNU [ef]grep become
> unusable without editing to remove the comment. It is completely
> infeasible, not to mention a tremendous waste of time, to edit
> everywhere on my systems that use them, after 40 years of historical
> usage.
>
> I'm not saying scripts intended to be portable should not be changed (as
> we know, they have had to be, because POSIX forced it). But all the
> scripts in the world which are *not* needed to be portable don't need to
> be changed. They just need to keep working and not be randomly broken by
> outside forces.
>
> [ef]grep are fundamental names for the utility. Please reconsider. -k
>
>
>




Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 6 Sep 2022 20:52:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 06 16:52:25 2022
Received: from localhost ([127.0.0.1]:52831 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVfYW-0003UV-T2
	for submit <at> debbugs.gnu.org; Tue, 06 Sep 2022 16:52:25 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:54720)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1oVfYT-0003UG-Il
 for 57604 <at> debbugs.gnu.org; Tue, 06 Sep 2022 16:52:23 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 7799B160051;
 Tue,  6 Sep 2022 13:52:15 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id TmRSeXzRisbz; Tue,  6 Sep 2022 13:52:14 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id AA424160057;
 Tue,  6 Sep 2022 13:52:14 -0700 (PDT)
DKIM-Filter: OpenDKIM Filter v2.9.2 zimbra.cs.ucla.edu AA424160057
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cs.ucla.edu;
 s=78364E5A-2AF3-11ED-87FA-8298ECA2D365; t=1662497534;
 bh=bbYj4WPMahir6CktqaShaq0BniwhY/Iwv8QeWuz2aJg=;
 h=Message-ID:Date:MIME-Version:Subject:To:From:Content-Type:
 Content-Transfer-Encoding;
 b=XZzOEx5LBaNzhLsSWHCXxYxqame83GcxBqBVOoUns8Il5mvPOUWmtgO6hTwE+AWW1
 81VFwWTKjqMVnBD3xxsITAR9AA6og//fwjuEho2v5KdH7tWdS0ME1emMGVH7ZeoJmm
 6sZqzlFUw/TzTi8E4zZfid4CDWKA6ElmCSJ7dIIg=
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id mbngtpUR3Nlz; Tue,  6 Sep 2022 13:52:14 -0700 (PDT)
Received: from [192.168.0.205] (ip72-206-2-24.fv.ks.cox.net [72.206.2.24])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 5A461160051;
 Tue,  6 Sep 2022 13:52:14 -0700 (PDT)
Message-ID: <f868951c-cf6a-c70e-8bc8-62ef9c81682c@HIDDEN>
Date: Tue, 6 Sep 2022 15:52:13 -0500
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Content-Language: en-US
To: Karl Berry <karl@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
 <202209062033.286KX06S017507@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
In-Reply-To: <202209062033.286KX06S017507@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 9/6/22 15:33, Karl Berry wrote:
> Since it bothers you to use POSIXLY_CORRECT, let's invent
> some other envvar that turns off the warning, like
> "PLEASE_LET_ME_USE_EFGREP_I_DONT_CARE_ABOUT_POSIX", and Arnold and I
> will set it and life can go on.

Python has PYTHONWARNINGS. I suppose GNU Grep could have a GREP_WARNINGS 
variable that could suppress these diagnostics from egrep and fgrep, 
along with diagnostics like these:

$ grep '\Q' /dev/null
grep: warning: stray \ before Q
$ grep '[:alpha:]' /dev/null
grep: character class syntax is [[:space:]], not [:space:]

We've been moving away from environment variables like GREP_OPTIONS, 
though, for security reasons. Perhaps we should let others comment.

In the meantime you can implement egrep and fgrep the way you like, as 
shell scripts in your private bin directory, as this is something you'll 
need for grep 3.8 anyway. And once you have that simple workaround, 
maybe we won't need the complexity of GREP_WARNINGS.





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 6 Sep 2022 20:33:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 06 16:33:13 2022
Received: from localhost ([127.0.0.1]:52811 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVfFx-0002zh-Jo
	for submit <at> debbugs.gnu.org; Tue, 06 Sep 2022 16:33:13 -0400
Received: from freefriends.org ([96.88.95.60]:60062)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oVfFu-0002zY-Vf
 for 57604 <at> debbugs.gnu.org; Tue, 06 Sep 2022 16:33:12 -0400
X-Envelope-From: karl@HIDDEN
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 286KX1ZI017508
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT); 
 Tue, 6 Sep 2022 14:33:02 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 286KX06S017507;
 Tue, 6 Sep 2022 14:33:00 -0600
Date: Tue, 6 Sep 2022 14:33:00 -0600
Message-Id: <202209062033.286KX06S017507@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: eggert@HIDDEN
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
In-Reply-To: <9807eef5-6424-f87c-3281-ed759fd26c56@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

    Actually, egrep and fgrep were not entirely portable 

They were portable to every system I ever used (admittedly not the
entire world), before POSIX got involved.

    These days, my impression is that it's more portable to use grep -E
    than to use egrep.

I agree. And IMHO that is a bug POSIX gratuitously introduced.

    That wouldn't be right, as POSIXLY_CORRECT governs misfeatures required 
    by POSIX, which isn't the case here: 

IMHO it is the case. The misfeature being fixed is POSIX unblessing
[ef]grep.

But, whatever. Since it bothers you to use POSIXLY_CORRECT, let's invent
some other envvar that turns off the warning, like
"PLEASE_LET_ME_USE_EFGREP_I_DONT_CARE_ABOUT_POSIX", and Arnold and I
will set it and life can go on.

    https://bugs.gnu.org/49996

I'm unconvinced. What Simon's bug report says is "hey, why not deprecate
[ef]grep because it's time". Well, IMHO it's not time, and will never be
time, and "deprecation" merely means "cause trouble for users for no
real reason". My "pet issue" is the exact opposite of Simon's ...

Without some way to turn off those warnings, GNU [ef]grep become
unusable without editing to remove the comment. It is completely
infeasible, not to mention a tremendous waste of time, to edit
everywhere on my systems that use them, after 40 years of historical
usage.

I'm not saying scripts intended to be portable should not be changed (as
we know, they have had to be, because POSIX forced it). But all the
scripts in the world which are *not* needed to be portable don't need to
be changed. They just need to keep working and not be randomly broken by
outside forces.

[ef]grep are fundamental names for the utility. Please reconsider. -k





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at 57604 <at> debbugs.gnu.org:


Received: (at 57604) by debbugs.gnu.org; 6 Sep 2022 01:29:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 05 21:29:01 2022
Received: from localhost ([127.0.0.1]:49219 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVNOf-0002x0-G7
	for submit <at> debbugs.gnu.org; Mon, 05 Sep 2022 21:29:01 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:36044)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1oVNOd-0002wl-26
 for 57604 <at> debbugs.gnu.org; Mon, 05 Sep 2022 21:28:59 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id D67231600BE;
 Mon,  5 Sep 2022 18:28:51 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id 7Vw4V2P-cRLX; Mon,  5 Sep 2022 18:28:50 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id DC1861600C0;
 Mon,  5 Sep 2022 18:28:50 -0700 (PDT)
DKIM-Filter: OpenDKIM Filter v2.9.2 zimbra.cs.ucla.edu DC1861600C0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=cs.ucla.edu;
 s=78364E5A-2AF3-11ED-87FA-8298ECA2D365; t=1662427730;
 bh=g7E3u2h2mwMGBwPCK2GsbILXu1Qe/Mn54e5ij8YbV1U=;
 h=Message-ID:Date:MIME-Version:Subject:To:From:Content-Type:
 Content-Transfer-Encoding;
 b=coSVnRWYY/aEKSwDCuLNlKokhqwGec7jUvtfvqKNIMqcPcVP1uVs6znYfVi2XeATO
 OShicZvdcbmLe5onOrVxzHNolvMZlZPjarHOewo/lA239qvGr6XjEmAFMZsN44KGgA
 PvQGZHljKpe8GbZosivcuX1G8jzx7rKWO8DvI2BU=
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id pXWYsVqEHKGP; Mon,  5 Sep 2022 18:28:50 -0700 (PDT)
Received: from [192.168.0.205] (ip72-206-2-24.fv.ks.cox.net [72.206.2.24])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 8D2081600BE;
 Mon,  5 Sep 2022 18:28:50 -0700 (PDT)
Message-ID: <9807eef5-6424-f87c-3281-ed759fd26c56@HIDDEN>
Date: Mon, 5 Sep 2022 20:28:49 -0500
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
Subject: Re: bug#57604: [ef]grep usage -> POSIXLY_CORRECT?
Content-Language: en-US
To: Karl Berry <karl@HIDDEN>
References: <202209052207.285M7Z3i005737@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
In-Reply-To: <202209052207.285M7Z3i005737@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57604
Cc: 57604 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 9/5/22 17:07, Karl Berry wrote:
> I have hundreds of scripts that use [ef]grep since for many
> years they were either the only, or then later the most portable, way to
> get the behavior.

Actually, egrep and fgrep were not entirely portable even before POSIX 
deprecated them in 2001. For example, in 1998 they were absent from SCO 
Unix unless you installed optional packages; see 
<https://www.scosales.com/ta/kb/105933.html>.

Similar problems are more common today now that POSIX no longer requires 
egrep and fgrep, for example, see OpenWRT bug 17803 
<https://github.com/openwrt/packages/issues/17803>. These days, my 
impression is that it's more portable to use grep -E than to use egrep. 
Of course neither is perfectly portable, but if a script is going to use 
just one or just the other, grep -E is the way to go nowadays.

>   I suggest giving that warning only if POSIXLY_CORRECT is set.
That wouldn't be right, as POSIXLY_CORRECT governs misfeatures required 
by POSIX, which isn't the case here: egrep and fgrep are extensions to 
POSIX.

For the bug report that prompted those warnings, please see:

https://bugs.gnu.org/49996





Information forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 5 Sep 2022 22:07:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 05 18:07:45 2022
Received: from localhost ([127.0.0.1]:49087 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVKFt-0004I9-3l
	for submit <at> debbugs.gnu.org; Mon, 05 Sep 2022 18:07:45 -0400
Received: from lists.gnu.org ([209.51.188.17]:47920)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <karl@HIDDEN>) id 1oVKFr-0004I2-HU
 for submit <at> debbugs.gnu.org; Mon, 05 Sep 2022 18:07:43 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:56332)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <karl@HIDDEN>)
 id 1oVKFr-0002u5-DP
 for bug-grep@HIDDEN; Mon, 05 Sep 2022 18:07:43 -0400
Received: from freefriends.org ([96.88.95.60]:39020)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <karl@HIDDEN>)
 id 1oVKFl-0002N1-9F
 for bug-grep@HIDDEN; Mon, 05 Sep 2022 18:07:42 -0400
X-Envelope-From: karl@HIDDEN
X-Envelope-To: <bug-grep@HIDDEN>
Received: from freefriends.org (freefriends.org [96.88.95.60])
 by freefriends.org (8.14.7/8.14.7) with ESMTP id 285M7ZbH005738
 (version=TLSv1/SSLv3 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=NOT)
 for <bug-grep@HIDDEN>; Mon, 5 Sep 2022 16:07:35 -0600
Received: (from apache@localhost)
 by freefriends.org (8.14.7/8.14.7/Submit) id 285M7Z3i005737;
 Mon, 5 Sep 2022 16:07:35 -0600
Date: Mon, 5 Sep 2022 16:07:35 -0600
Message-Id: <202209052207.285M7Z3i005737@HIDDEN>
From: Karl Berry <karl@HIDDEN>
To: bug-grep@HIDDEN
Subject: [ef]grep usage -> POSIXLY_CORRECT?
Received-SPF: pass client-ip=96.88.95.60; envelope-from=karl@HIDDEN;
 helo=freefriends.org
X-Spam_score_int: -41
X-Spam_score: -4.2
X-Spam_bar: ----
X-Spam_report: (-4.2 / 5.0 requ) BAYES_00=-1.9, RCVD_IN_DNSWL_MED=-2.3,
 SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

It is painful to see the unconditional complaint (grep 3.8) about
[ef]grep usage when those programs have been present since the beginning
of Unix. I have hundreds of scripts that use [ef]grep since for many
years they were either the only, or then later the most portable, way to
get the behavior.

So, I suggest giving that warning only if POSIXLY_CORRECT is set.  Seems to
me this is a case for which that is intended. -k




Acknowledgement sent to Karl Berry <karl@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-grep@HIDDEN. Full text available.
Report forwarded to bug-grep@HIDDEN:
bug#57604; Package grep. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 19 Sep 2022 20:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.